unit AJPaintFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  PNGImage,   Menus,
  janShapeController, janShape, janShapeEditor,
  ComCtrls, ExtCtrls;

type
  TGPaintForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    Tools1: TMenuItem;
    Help1: TMenuItem;
    Paint1: TMenuItem;
    About1: TMenuItem;
    janShapeController1: TjanShapeController;
    AddShape1: TMenuItem;
    CreateShape1: TMenuItem;
    Print1: TMenuItem;
    Mouse1: TMenuItem;
    MouseMove1: TMenuItem;
    MouseResize1: TMenuItem;
    TextMove1: TMenuItem;
    N1: TMenuItem;
    SelectShapw1: TMenuItem;
    TextRotate1: TMenuItem;
    SaveShp1: TMenuItem;
    OpenShps1: TMenuItem;
    SaveDialog1: TSaveDialog;
    PaintShape1: TMenuItem;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    janShape1: TjanShape;
    StatusBar1: TStatusBar;
    OpenDialog1: TOpenDialog;
    NewBlank1: TMenuItem;
    UseTongs1: TMenuItem;
    Load1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    CopytoTongs1: TMenuItem;
    N4: TMenuItem;
    Save2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Paint1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure CreateShape1Click(Sender: TObject);

    procedure AddShape1Click(Sender: TObject);

    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
procedure DrawShape
  (TopLeft, BottomRight, Tri, Quad: TPoint; AMode: TPenMode);
procedure DrawGhost;
    procedure SelectShapw1Click(Sender: TObject);
    procedure MouseMove1Click(Sender: TObject);
    procedure MouseResize1Click(Sender: TObject);
    procedure TextMove1Click(Sender: TObject);
    procedure TextRotate1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure SaveShp1Click(Sender: TObject);
    procedure PaintShape1Click(Sender: TObject);
    procedure OpenShps1Click(Sender: TObject);
    procedure NewBlank1Click(Sender: TObject);
    procedure UseTongs1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure Save2Click(Sender: TObject);
    procedure CopytoTongs1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  GPaintForm: TGPaintForm;
  Selecting,Creating:Boolean;
  X1,Y1:Integer;
implementation

uses TongGlobals, TongsFrm;

{$R *.DFM}

procedure TGPaintForm.FormCreate(Sender: TObject);
begin
  janshapecontroller1.CreateMenu;
  Creating:=False;
  Selecting:=False;
end;

procedure TGPaintForm.FormShow(Sender: TObject);
begin
  left := GPaintFormX;
  top := GPaintFormY;
end;

procedure TGPaintForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GPaintFormX := GPaintForm.left;
  GPaintFormY := GPaintForm.top;
end;
procedure TGPaintForm.Exit1Click(Sender: TObject);
begin
  Close;
end;
procedure TGPaintForm.Paint1Click(Sender: TObject);
begin
  Application.HelpContext(17000);
end;

procedure TGPaintForm.About1Click(Sender: TObject);
begin
   ShowMessage(
    'Jan Shape:   version  1.0'+#13#10+
    'Copyright  2000-2001 Jan Verhoeven'+#13#10+
    'http://jansfreeware.com/freeware.htm');
end;

procedure TGPaintForm.Open1Click(Sender: TObject);
var appldir:String;
begin
  appldir:=extractfilepath(paramstr(0));
  if fileexists(appldir+'default.psf') then
  begin
    janshapecontroller1.UserShapes.LoadFromFile(appldir+'default.psf');
    janshapecontroller1.CreateMenu;
  end;
end;

procedure TGPaintForm.Save1Click(Sender: TObject);
var appldir:String;
begin
  appldir:=extractfilepath(paramstr(0));
  janshapecontroller1.UserShapes.SaveToFile(appldir+'default.psf');
end;


procedure TGPaintForm.CreateShape1Click(Sender: TObject);
var
  ShapeForm: TShapeEditorForm;
  obj:TjanShapeController;
  I:Integer;
begin
  I:=0;
  try
  ShapeForm:=TShapeEditorForm.Create (application);
  inc(I);{:=1;}
  obj:=janShapeController1;
  ShapeForm.UserList.items.assign(obj.usershapes);
  if ShapeForm.showmodal=mrOK then
  begin
     obj.usershapes.Assign (ShapeForm.userlist.items);
     obj.CreateMenu;
  end;
    {If I=1 then }shapeForm.free;
  finally
    If I=0 then
    begin
    DoMessages(39999);
   { shapeForm.free;}
    end;
  end;
end;

procedure TGPaintForm.AddShape1Click(Sender: TObject);
begin
Creating:= (not Creating);
end;
procedure TGPaintForm.SelectShapw1Click(Sender: TObject);
begin
Selecting :=(not Selecting);
end;

procedure TGPaintForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
      if ((Creating = True)or (Selecting = True)) then
      begin
        DrawingTool := dtRectangle;
        Drawing := True;
        {Image1.}Canvas.MoveTo(X, Y);
        Origin := Point(X, Y);
        X1:=X; Y1:=Y;
        MovePt := Point(X, Y); { keep track of where this move was }
      end;
end;

procedure TGPaintForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Drawing then  {Crops >3 are rectangles}
  begin
    if ((DrawingTool = dtRectangle) or
        (DrawingTool = dtLine) ) then
      begin
            DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
            MovePt := Point(X, Y);
            DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
      end;
  end;
end;

procedure TGPaintForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  L,T,W,H : Integer;
  NewObj : TjanShape;
begin
 if Button <> mbLeft then exit;
  if Drawing then  {Crops >3 are rectangles}
  begin
    DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
    DrawingTool := dtLine;
    Drawing := False;
    MovePt := Point(X, Y);
  end;
  if Creating then
  begin
  Creating:= (not Creating);
  DrawGhost;
  if (X<=X1) or (Y<=Y1) then exit;
  NewObj := TjanShape.Create(Self);
  with NewObj do
    begin
      Parent := self;
      Shape := jstRectangle;{ObjType;}
      PopupMenu := janShapeController1;
      ActiveMouse:=true;
      MouseMode:=mmMoveObject;
      L := X1; W := X-X1;
      T := Y1; H := Y-Y1;
      if Shape{ObjType} in [jstCircle,jstSquare,jstRoundSquare] then
        if W < H then H := W else W := H;
      SetBounds(L,T,W,H);
    end;
  janShapeController1.AddObj (NewObj);
  {janShapeController1.CountObjects;}
  end
  else
  begin
    Selecting :=(not Selecting);
{    canvas.DrawFocusRect(rect(x1,y1,x,y)); }
    janShapeController1.SelectRect(Rect(x1,y1,x,y));
  end;
end;
//-----------------------------------------------------
procedure TGPaintForm.DrawShape
  (TopLeft, BottomRight, Tri, Quad: TPoint; AMode: TPenMode);
begin
  with {Image1.}Canvas do
  begin
    Pen.Mode := AMode;
    case DrawingTool of
      dtLine:
        begin
          {Image1.}Canvas.MoveTo(TopLeft.X, TopLeft.Y);
          {Image1.}Canvas.LineTo(BottomRight.X, BottomRight.Y);
        end;
      dtRectangle:
        {Image1.}Canvas.Rectangle
          (TopLeft.X, TopLeft.Y, BottomRight.X, BottomRight.Y);
    end;
  end;
end;

procedure TGPaintForm.DrawGhost;
begin
{}
end;
{
The janShapeController1.AddObj (NewObj); statement
adds the object to a TList in TjanShapeController.
Every shape added this way can be manipulated
using the shapecontroller.
The user can select several shapes
by shift-clicking them
and the shape controller will treat them as a group
when moving one of the shapes.
}
{The MouseMode property can also be set from the program.
To allow movement of any TjanShape object that you select:
  janshapecontroller1.MouseModeController :=true;
  janshapecontroller1.MouseMode :=mmMoveText;
In the mousedown event of a TjanShape
a check is done if MouseModeController of the
connected TjanShapeController is set to true.
If so the MouseMode of the TjanShapeController
will be copied to the TjanShape.MouseMode.}
procedure TGPaintForm.MouseMove1Click(Sender: TObject);
begin
  janshapecontroller1.MouseModeController :=true;
  janshapecontroller1.MouseMode :=mmMoveObject;
end;

procedure TGPaintForm.MouseResize1Click(Sender: TObject);
begin
  janshapecontroller1.MouseModeController :=true;
  janshapecontroller1.MouseMode :=mmSizeObject;
end;

procedure TGPaintForm.TextMove1Click(Sender: TObject);
begin
  janshapecontroller1.MouseModeController :=true;
  janshapecontroller1.MouseMode :=mmMoveText;
end;

procedure TGPaintForm.TextRotate1Click(Sender: TObject);
begin
  janshapecontroller1.MouseModeController :=true;
  janshapecontroller1.MouseMode :=mmRotateText;
end;

procedure TGPaintForm.Print1Click(Sender: TObject);
begin
{janShapeController1.PrintShapes(
  janShapeController1.FObjlist,1.0); }
end;(*
var i,c{,x,y}:integer;
{    w,h:integer;   }
    obj:TjanShape;
{    R:Trect;  }
    Ax0,Ay0:integer;
    AScaleX,ascaleY:extended;
begin
  c:=alist.Count ;
  if c=0 then exit;
  AScaleX:=scale*GetDeviceCaps(Printer.Handle, LOGPIXELSX) / Screen.PixelsPerInch;
  AScaleY:=scale*GetDeviceCaps(Printer.Handle, LOGPIXELSY) / Screen.PixelsPerInch;
  printer.BeginDoc;
  for i:=0 to c-1 do
  begin
    obj:=TjanShape(alist[i]);
    Ax0:=round(AscaleX*obj.Left) ;
    Ay0:=round(AscaleY*obj.top);
    obj.PaintToCanvas (printer.canvas,Ax0,ay0,AScaleX,AscaleY);
  end;
  printer.EndDoc ;
end;*)

procedure TGPaintForm.SaveShp1Click(Sender: TObject);
begin
  SaveDialog1.Filter:='*.obd';
  if SaveDialog1.Execute then
   janShapeController1.SaveAll(SaveDialog1.Filename);
end;

procedure TGPaintForm.OpenShps1Click(Sender: TObject);
{var
  fs:TFilestream;
  i:integer;
  AShape:TjanShape;}
begin
  OpenDialog1.Filter:='*.obd';
  if OpenDialog1.Execute then
  begin
{
    janShapeController1.ClearAll;
    FS := TFileStream.Create(OpenDialog1.filename,fmCreate or fmShareDenyWrite);
      AShape.Create(janShape1);
    try
      FS.ReadComponent(AShape);
      janShapeController1.AddObj(AShape);
    finally FS.Free;  end;
}
  end;
end;

procedure TGPaintForm.PaintShape1Click(Sender: TObject);
var
    obj:TjanShape;
    c,i,
    Ax0,Ay0:integer;
    AScaleX,ascaleY:extended;
begin
  if not Image1.Picture.Bitmap.Empty then
  begin
  c:=1;{alist.Count ;}
  if c=0 then exit;
  for i:=0 to c-1 do
  begin
    obj:=TjanShape(1{alist[i]});
    AScaleX:=1;
    AScaleY:=1;                      {Image1.Picture.Bitmap.}
    Ax0:=round(AscaleX*obj.Left) ;
    Ay0:=round(AscaleY*obj.top);
    obj.PaintToCanvas (Image1.canvas,Ax0,ay0,AScaleX,AscaleY);
  end;
  end;
{    procedure PaintToCanvas(acanvas: TCanvas;Ax0,Ay0:integer;AScaleX,AscaleY:extended);
}
end;



procedure TGPaintForm.NewBlank1Click(Sender: TObject);
var Target:TBitmap;
begin
          Target := TBitmap.Create;
          Target.PixelFormat := MyPixelFormat;
          Target.Width := TongsForm.Image1.Picture.Width;
          Target.Height := TongsForm.Image1.Picture.Height;
          Image1.Picture.Bitmap.assign(Target);
          Target.Free;
end;

procedure TGPaintForm.UseTongs1Click(Sender: TObject);
var Target:TBitmap;
begin
          Target := TBitmap.Create;
          Target.PixelFormat := MyPixelFormat;
          Target.Width := TongsForm.Image1.Picture.Width;
          Target.Height := TongsForm.Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, TongsForm.Image1.Picture.Graphic);
          Image1.Picture.Bitmap.assign(Target);
          Target.Free;
end;

procedure TGPaintForm.Load1Click(Sender: TObject);
begin
    OpenDialog1.InitialDir := ImagePath;
    OpenDialog1.Filter := 'All (*.bmp;*.png)|*.bmp;*.png;*.jpg';
    if OpenDialog1.Execute then
    begin
      ImagePath := ExtractFilePath(OpenDialog1.Filename);
      TongFilename := ExtractFileName(OpenDialog1.Filename);
      Image1.Picture.LoadFromFile(TongFilename);
    end;
end;

procedure TGPaintForm.Save2Click(Sender: TObject);
var
 PNG:TPNGObject;
begin
  SaveDialog1.filter := 'Image files|*.PNG;*.bmp';
  SaveDialog1.DefaultExt := 'PNG';
  if SaveDialog1.Execute then {Save it}
  begin
    if ( Uppercase(ExtractFileExt(SaveDialog1.FileName)) = '.PNG') then
    begin
      TongFilename := ExtractFileName(SaveDialog1.FileName);
      ImagePath := ExtractFilePath(SaveDialog1.FileName);
    PNG := TPNGObject.Create;
    {In case something goes wrong, free both PNG and Bitmap}
    try
      Image1.Picture.Bitmap.PixelFormat := ImagePixelFormat;//pf24bit;
      PNG.Assign(TBitmap(Image1.Picture.Graphic)); //Convert data into png
      PNG.SaveToFile(SaveDialog1.FileName);
      finally
      PNG.Free;
    end;
    end
    else Image1.Picture.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TGPaintForm.CopytoTongs1Click(Sender: TObject);
begin
  TongsForm.Image1.Picture.Graphic:=
      Image1.Picture.Graphic;
  TongsForm.SetFormCaption;
end;

end.
