unit DBAFrm;

interface

uses
  SysUtils, Windows, Messages, Classes,
  Graphics, Controls, Forms, StdCtrls,
  JPEG, PNGImage, GraphicEx,
  DBCtrls, DBGrids, DB, DBTables, Buttons,
  Grids, ExtCtrls, Mask, Menus,
  Dialogs;

type
  TDBAForm = class(TForm)
    Panel1: TPanel;
    Table1: TTable;
    DataSource1: TDataSource;
    DBMemo1: TDBMemo;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Print1: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    Panel2: TPanel;
    DBImage1: TDBImage;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    Panel3: TPanel;
    DBNavigator1: TDBNavigator;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DbtheFloatingFileList1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
procedure OpenFromAfar(InName:String);
procedure BrowseList(NewAlbum:String);
procedure AddToDbTree(
           LatY ,LonX ,Direction,  Name:String);
    procedure DbtheFloatingFileList1Click(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
  end;

var
  DBAForm: TDBAForm;

implementation

{$R *.DFM}
uses   TongGlobals, PicView, Preprint, TongsFrm;
//-----------------------------------------------------
{THIS is for Pic Album and Tree Direction, OTHER uses
 NOT another INNER database}
procedure TDBAForm.FormCreate(Sender: TObject);
begin
with table1.fielddefs do
begin
clear;
          {(ImageLink   + key  autoincrement}
          with AddFieldDef do
          begin
            FieldNo:=1;
            Name := 'ImageLink';
            DataType := ftInteger;
            Required:=True;
          end;
{add ('ImageLink',ftInteger,True);}
add ('Name',ftstring,200,true);
add ('Type',ftstring,6,false);
add ('Date',ftstring,10,false);
add ('LatY',ftFloat{,false});
add ('LonX',ftFloat{,false});
add ('Direction',ftInteger{,false});
add ('CommonName',ftstring,30,false);
add ('Notes',ftMemo,10,false);
add ('BLOBIMAGE',ftBlob,0,false);
end;
  {ImageLink,Name,Type,Date,LatY 90,LonX 180,Direction 360,
   CommonName,Notes,BLOBIMAGE}
table1.indexdefs.clear;
table1.indexdefs.add('','ImageLink',[ixprimary]);
end;
{  (ImageLink   I key
  Name       A200        A256 key
  Type       A6
  Date       A10   0
  LatY N           90
  LonX N           180
  Direction I       360
  CommonName A30
  Notes      M 10
  BLOBIMAGE  B}

procedure TDBAForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    DBAFormX := DBAForm.left;
    DBAFormY := DBAForm.top;
end;

procedure TDBAForm.FormShow(Sender: TObject);
begin
  top := DBAFormY;
  left := DBAFormX;
end;

procedure TDBAForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TDBAForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(9000);
end;

procedure TDBAForm.Print1Click(Sender: TObject);
begin                         {Filename}
  ViewFileName:=(table1.fields[1].asstring);
  If FileExists(ViewFileName) then
  begin
    with PicViewBitmap do
    begin
      DoLoad(ViewFileName);
      FocusedListBox:= nil;
      Show;
    end;
  PrePrintForm:=TPrePrintForm.Create(Application);
  try
    PrePrintForm.TitleEdit.Lines[0]:=table1.fieldbyname('CommonName').asstring;
    PrePrintForm.AuthorEdit.Text:=table1['Notes'];
    PrePrintForm.SetupForm(ViewFileName,1);
    PicViewBitmap.Image1.Picture.Graphic:=nil;
    PicViewBitmap.Close;
    PrePrintForm.ShowModal;
  finally
    PrePrintForm.Release;
  end;
  end else Showmessage('File '+ViewFileName+' not there');
end;



procedure TDBAForm.Open1Click(Sender: TObject);
begin
  OpenDialog1.Filter := 'Family Image database|*.db';
  OpenDialog1.FileName:='????imag.db';
  OpenDialog1.InitialDir:=ThumbPath;
  If OpenDialog1.Execute then
  begin
    OpenFromAfar(OpenDialog1.Filename);
  end;
end;

procedure TDBAForm.OpenFromAfar(InName:String);
var DbName:String;
begin
    table1.active := false ;
    table1.databasename :=ExtractFilePath(InName);
    DbName :=ExtractFileName(InName);
    table1.tablename :=DbName;
    table1.tabletype := ttparadox ;
    {createtable;}

    {Load form with database}
    DBEdit1.DataField:='CommonName';
    DBEdit2.DataField:='Date';
    DBEdit3.DataField:='LatY';
    DBEdit4.DataField:='LonX';
    DBEdit5.DataField:='Direction';
    DBMemo1.DataField:='Notes';
    DBImage1.DataField:='BLOBIMAGE';
    table1.active:=true;
end;
{  (ImageLink   I key
  Name       A200        A256 key
  Type       A6
  Date       A10   0
  LatY N           90
  LonX N           180
  Direction I       360
  CommonName A30
  Notes      M 10
  BLOBIMAGE  B}
procedure TDBAForm.DbtheFloatingFileList1Click(Sender: TObject);
var DbName:String;
begin
  DbName :=ExtractFileName(ExtractFilePath(ResultFileList.Strings[1]));
  DbName :=ThumbPath+'\'+DbName;  {ResultFileList}
  BrowseList(DbName);
end;

//-----------------------------------------------------
procedure TDBAForm.BrowseList(NewAlbum:String);
var
  ImageLinker,  AdjustWidth,AdjustHeight,
  CheckMate,i,dim,larg,alt:integer;
  blob,mybit:tbitmap;
  myhandle:thandle;
  DataName,MyFileName,DbName,Date,Time:string;
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  Target:TBitmap;
begin
  DbName :=NewAlbum+ '.db';
  CheckMate:= mrNo;   {Replace the Table}
  if FileExists(ThumbPath+'\'+DbName)then
  CheckMate:= DoConfirm(10002);
  If CheckMate= mrCancel then exit;
  If DBImage1.Height < Thumbsize then screen.cursor:=crhourglass;
  If CheckMate= mrNo then
  Begin   {Replace the Table}
  with table1 do
  begin
    if ResultFileList.Count>0 then
    begin
      ResultFileList.Sorted:=True;
      active := false ;
      databasename :=ThumbPath;
      tablename :=DbName;
      tabletype := ttparadox ;
      createtable;
      active:=true;
      {cancel;}
      for i:=0 to ResultFileList.Count-1 do
      begin
        mybit:=tbitmap.create;
        MyFileName:=ResultFileList.Strings[i];
        GraphicClass := FileFormatList.GraphicFromContent(MyFileName);
        if GraphicClass = nil then Image1.Picture.LoadFromFile(MyFileName)
        else
        begin
        // GraphicFromContent always returns TGraphicExGraphicClass
          Graphic := GraphicClass.Create;
          Graphic.LoadFromFile(MyFileName);
          Image1.Picture.Graphic := Graphic;
        end;
        if (not(Image1.Picture.Graphic is TBitmap)) then
        begin
          Target := TBitmap.Create;
          Target.PixelFormat := pf24Bit;
          Target.Width := Image1.Picture.Width;
          Target.Height := Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
          Image1.Picture.Graphic := Target;
          Target.Free;
        end;
        Image1.Picture.Bitmap.PixelFormat := pf24bit;
        mybit.assign(Image1.Picture.Bitmap);
        mybit.PixelFormat:=pf24bit;
        Application.ProcessMessages;
        larg:=mybit.width;
        alt:=mybit.height;

    dim:=DBImage1.Width;{Thumbsize;}
    if larg=0 then
    larg:=10;
    if alt=0 then
    alt:=10;
    blob:=tbitmap.create;
    blob.PixelFormat:=pf24bit;
    blob.Width:=dim;
    blob.height:=dim;
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
    if larg>alt then
    begin
      Target.Width:=dim;
      Target.height:=round(alt/larg*dim);
      AdjustWidth:=0;
      AdjustHeight:= Target.width-Target.height;
    end
    else
    begin
      Target.height:=dim;
      Target.width:=round(larg/alt*dim);
      AdjustWidth:=Target.height-Target.width;
      AdjustHeight:=0;
    end;
    Application.ProcessMessages;
    Stretch(Target.width{NewX}, Target.height{NewY},
    TResamplingFilter(GraphexFilter), 0,
                        mybit, Target);
    blob.Canvas.Brush.Color:=ThumbColor;
    blob.Canvas.FillRect(Rect(0,0,dim,dim));
    blob.canvas.Draw(0+(AdjustWidth div 2),
                     0+(AdjustHeight div 2),
                     Target);
    mybit.free;
    Target.free;
    Application.ProcessMessages;

        myhandle:=fileopen(ResultFileList.Strings[i],fmopenread);
        Date:=datetostr(filedatetodatetime(filegetdate(myhandle)));
        Time:=timetostr(filedatetodatetime(filegetdate(myhandle)));
        DataName:=extractfilename(ResultFileList.Strings[i]);
        If Length(DataName) >29 then SetLength(DataName ,29);

  If table1.RecordCount =0 then
  begin
    ImageLinker :=1;
  end else
  begin
    table1.Last;
    ImageLinker:=table1.Fields[0].Value;
    inc(ImageLinker);
  end;
  table1.AppendRecord([
  ImageLinker,MyFileName,uppercase(extractfileext(MyFileName)),
  Date,90,180,360,DataName,'...',blob ]);
  {ImageLink,Name,Type,Date,LatY 90,LonX 180,Direction 360,
   CommonName,Notes,BLOBIMAGE}

        fileclose(myhandle);
        blob.free;
      end;
    end;
  end;
end else If CheckMate= mrYes then
BEGIN {append}
  with table1 do
  begin
    if ResultFileList.Count>0 then
    begin
      ResultFileList.Sorted:=True;
      for i:=0 to ResultFileList.Count-1 do
      begin
        MyFileName:=ResultFileList.Strings[i];
      If (not  findkey([MyFileName])) then
      BEGIN
        mybit:=tbitmap.create;
        GraphicClass := FileFormatList.GraphicFromContent(MyFileName);
        if GraphicClass = nil then Image1.Picture.LoadFromFile(MyFileName)
        else
        begin
        // GraphicFromContent always returns TGraphicExGraphicClass
          Graphic := GraphicClass.Create;
          Graphic.LoadFromFile(MyFileName);
          Image1.Picture.Graphic := Graphic;
        end;
        if (not(Image1.Picture.Graphic is TBitmap)) then
        begin
          Target := TBitmap.Create;
          Target.PixelFormat := pf24Bit;
          Target.Width := Image1.Picture.Width;
          Target.Height := Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
          Image1.Picture.Graphic := Target;
          Target.Free;
        end;
        Image1.Picture.Bitmap.PixelFormat := pf24bit;
        mybit.assign(Image1.Picture.Bitmap);
        mybit.PixelFormat:=pf24bit;
    Application.ProcessMessages;
        larg:=mybit.width;
        alt:=mybit.height;
        dim:=DBImage1.Width;{Thumbsize;}
        if larg=0 then
        larg:=10;
        if alt=0 then
        alt:=10;
        blob:=tbitmap.create;
        blob.PixelFormat:=pf24bit;
    blob.Width:=dim;
    blob.height:=dim;
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
        if larg>alt then
        begin
      Target.Width:=dim;
      Target.height:=round(alt/larg*dim);
      AdjustWidth:=0;
      AdjustHeight:= Target.width-Target.height;
        end
        else
        begin
      Target.height:=dim;
      Target.width:=round(larg/alt*dim);
      AdjustWidth:=Target.height-Target.width;
      AdjustHeight:=0;
        end;
    Application.ProcessMessages;
    Stretch(Target.width{NewX}, Target.height{NewY},
    TResamplingFilter(GraphexFilter), 0,
                        mybit, Target);
    blob.Canvas.Brush.Color:=ThumbColor;
    blob.Canvas.FillRect(Rect(0,0,dim,dim));
    blob.canvas.Draw(0+(AdjustWidth div 2),
                     0+(AdjustHeight div 2),
                     Target);
    mybit.free;
    Target.free;
    Application.ProcessMessages;
        mybit.free;
        myhandle:=fileopen(ResultFileList.Strings[i],fmopenread);
        Date:=datetostr(filedatetodatetime(filegetdate(myhandle)));
        Time:=timetostr(filedatetodatetime(filegetdate(myhandle)));
        DataName:=extractfilename(ResultFileList.Strings[i]);
        If Length(DataName) >29 then SetLength(DataName ,29);

  If table1.RecordCount =0 then
  begin
    ImageLinker :=1;
  end else
  begin
    table1.Last;
    ImageLinker:=table1.Fields[0].Value;
    inc(ImageLinker);
  end;
  table1.AppendRecord([
  ImageLinker,MyFileName,uppercase(extractfileext(MyFileName)),
  Date,90,180,360,DataName,'...',blob ]);
  {ImageLink,Name,Type,Date,LatY 90,LonX 180,Direction 360,
   CommonName,Notes,BLOBIMAGE}
        fileclose(myhandle);
        blob.free;
      END;
      end;
    end;
  end;
END;
      {Load form with database}
      DBEdit1.DataField:='CommonName';
      DBEdit2.DataField:='Date';
      DBEdit3.DataField:='LatY';
      DBEdit4.DataField:='LonX';
      DBEdit5.DataField:='Direction';
      DBMemo1.DataField:='Notes';
      DBImage1.DataField:='Image';
      table1.First;
      screen.cursor:=crdefault;
end;
//-----------------------------------------------------
procedure TDBAForm.AddToDbTree(
           LatY ,LonX ,Direction,  Name:String);
var
  ImageLinker,  AdjustWidth,AdjustHeight,
  dim,larg,alt:integer;
  blob,mybit:tbitmap;
  myhandle:thandle;
  DataName,MyFileName,Date,Time:string;
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  Target:TBitmap;
Begin
        mybit:=tbitmap.create;
        MyFileName:=Name;
        GraphicClass := FileFormatList.GraphicFromContent(MyFileName);
        if GraphicClass = nil then Image1.Picture.LoadFromFile(MyFileName)
        else
        begin
        // GraphicFromContent always returns TGraphicExGraphicClass
          Graphic := GraphicClass.Create;
          Graphic.LoadFromFile(MyFileName);
          Image1.Picture.Graphic := Graphic;
        end;
        if (not(Image1.Picture.Graphic is TBitmap)) then
        begin
          Target := TBitmap.Create;
          Target.PixelFormat := pf24Bit;
          Target.Width := Image1.Picture.Width;
          Target.Height := Image1.Picture.Height;
          Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
          Image1.Picture.Graphic := Target;
          Target.Free;
        end;
        Image1.Picture.Bitmap.PixelFormat := pf24bit;
        mybit.assign(Image1.Picture.Bitmap);
        mybit.PixelFormat:=pf24bit;
        Application.ProcessMessages;
        larg:=mybit.width;
        alt:=mybit.height;

    dim:=DBImage1.Width;{Thumbsize;}
    if larg=0 then
    larg:=10;
    if alt=0 then
    alt:=10;
    blob:=tbitmap.create;
    blob.PixelFormat:=pf24bit;
    blob.Width:=dim;
    blob.height:=dim;
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
    if larg>alt then
    begin
      Target.Width:=dim;
      Target.height:=round(alt/larg*dim);
      AdjustWidth:=0;
      AdjustHeight:= Target.width-Target.height;
    end
    else
    begin
      Target.height:=dim;
      Target.width:=round(larg/alt*dim);
      AdjustWidth:=Target.height-Target.width;
      AdjustHeight:=0;
    end;
    Application.ProcessMessages;
    Stretch(Target.width{NewX}, Target.height{NewY},
    TResamplingFilter(GraphexFilter), 0,
                        mybit, Target);
    blob.Canvas.Brush.Color:=ThumbColor;
    blob.Canvas.FillRect(Rect(0,0,dim,dim));
    blob.canvas.Draw(0+(AdjustWidth div 2),
                     0+(AdjustHeight div 2),
                     Target);
    mybit.free;
    Target.free;
    Application.ProcessMessages;

        myhandle:=fileopen(MyFileName,fmopenread);
        Date:=datetostr(filedatetodatetime(filegetdate(myhandle)));
        Time:=timetostr(filedatetodatetime(filegetdate(myhandle)));
        DataName:=extractfilename(MyFileName);
        If Length(DataName) >29 then SetLength(DataName ,29);

  If table1.RecordCount =0 then
  begin
    ImageLinker :=1;
  end else
  begin
    table1.Last;
    ImageLinker:=table1.Fields[0].Value;
    inc(ImageLinker);
  end;
  table1.AppendRecord([
  ImageLinker,MyFileName,uppercase(extractfileext(MyFileName)),
  Date,
  Strtofloat(LatY),
  Strtofloat(LonX),
  StrtoInt(Direction),
  {90,180,360,}DataName,'...',blob ]);
  {ImageLink,Name,Type,Date,LatY 90,LonX 180,Direction 360,
   CommonName,Notes,BLOBIMAGE}

        fileclose(myhandle);
        blob.free;
End;
//-----------------------------------------------------




(******************************************************)
(******************************************************)




end.
