unit DbImporterFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Menus, Db, DBTables, StdCtrls, Buttons, ExtCtrls;

type
  TDatabaseImporterForm = class(TForm)
    OpenDialog: TOpenDialog;
    DataSource1: TDataSource;
    Table1: TTable;
    Panel1: TPanel;
    PhoneEdit: TEdit;
    PhoneCB: TCheckBox;
    EMailCB: TCheckBox;
    EMailEdit: TEdit;
    ZipEdit: TEdit;
    ZipCB: TCheckBox;
    StateCB: TCheckBox;
    StateEdit: TEdit;
    CityEdit: TEdit;
    CityCB: TCheckBox;
    AddressCB: TCheckBox;
    AddressEdit: TEdit;
    AEdit: TEdit;
    ACB: TCheckBox;
    LastNameCB: TCheckBox;
    LastNameEdit: TEdit;
    FirstNameEdit: TEdit;
    FirstNameCB: TCheckBox;
    Label2: TLabel;
    Label1: TLabel;
    Edit1: TEdit;
    Label10: TLabel;
    AppendImportedBtn: TSpeedButton;
    ImportAddressesBtn: TSpeedButton;
    Panel2: TPanel;
    CreateBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);

    procedure CreateBtnClick(Sender: TObject);
    procedure Open1Click(Sender: TObject);
function RunTimeDbCreate(const DatabaseName, SessionName: String): TDatabase;
    procedure AppendImportedBtnClick(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DatabaseImporterForm: TDatabaseImporterForm;
  DBFileName:String;

implementation

{$R *.DFM}

uses TongGlobals;

procedure TDatabaseImporterForm.FormCreate(Sender: TObject);
begin
  top := DatabaseImporterFormY;
  left := DatabaseImporterFormX;
end;

procedure TDatabaseImporterForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DatabaseImporterFormY := DatabaseImporterForm.top;
  DatabaseImporterFormX := DatabaseImporterForm.left;
end;

procedure TDatabaseImporterForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TDatabaseImporterForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(9123);
end;


(******************************************************)
(******************************************************)
  {Make a database table}
(******************************************************)
(******************************************************)
procedure TDatabaseImporterForm.CreateBtnClick(Sender: TObject);
var
 FakeDb: TTable;
  NewIndexOptions: TIndexOptions;
  LinkTableTableName,
  DBFileName:String;
  MyDatabase: array [1..10] of  TDatabase;
  MyDbCount: Integer;
begin
  OpenDialog.InitialDir:=DbPath;
  OpenDialog.Filter := 'Db files (*.db)|*.db';
  OpenDialog.Filename:='*.db';
  if OpenDialog.Execute then
  begin
    If not FileExists(OpenDialog.FileName) then
    begin
      DBFileName:=ExtractFileName(OpenDialog.FileName);
      DBFileName:=Copy(ExtractFileName(DBFileName),1,Length(DBFileName)-3);
      DbPath:=ExtractFilePath(OpenDialog.FileName);
      FakeDb := TTable.Create(Application);
      NewIndexOptions := [ixPrimary, ixUnique];
      {  Fmlydata.DB : GoldTable-DataSource2 }
      with FakeDb do
      begin
        { The Table component must not be active }
        Active := False;
        { First, describe the type of table and give }
        { it a name }
        DatabaseName := 'ILH';
        TableType := ttParadox;
        TableName:=DbPath+DBFileName + 'Data.db';
{showmessage(VRMDatabase+DBFileName + 'data.db');}
        { Next, describe the fields in the table }
        with FieldDefs do
        begin
          Clear;
(*
(  Fmlydata.DB : DataTable-DataDS
Last Name     A20 key
First Name    A20 key
FamilyLink    I    made upon appending    FLink
ParentLink    F   0  Floating Point       PLink  ???
AddLink       I   0   //This links to an (1) address
Spouse        I
Father        I
Mother        I
Rcvd            L    True
Sent             L    True
Married        L    
Child           L    
Deceased    L    
Male             L    
Relation   Size = 10
*)
          with AddFieldDef do
          begin
            FieldNo:=1;{Last Name     A20 key}
            Name := 'Last Name';
            DataType := ftString;
            Size:=20 ;
            Required:=True;
          end;
          with AddFieldDef do
          begin
            FieldNo:=2;{First Name    A20 key}
            Name := 'First Name';
            DataType := ftString;
            Size:=20;
            {Precision:=20;}
            Required:=True;
          end;
          with AddFieldDef do
          begin
            FieldNo:=3;{FamilyLink    I           FLink}
            Name := 'FamilyLink';
            DataType := ftInteger;
{            Size:=1 ;
            Precision:=1;}
            Required:=False;
          end;
          with AddFieldDef do
          begin
            FieldNo:=4;{Rcvd          L    True}
            Name := 'Rcvd';
            DataType := ftBoolean;
{            Size:=1 ;
            Precision:=1;}
            Required:=False;
          end;
          with AddFieldDef do
          begin
            FieldNo:=5;{Sent          L    True}
            Name := 'Sent';
            DataType := ftBoolean;
{            Size:=1 ;
            Precision:=1;}
            Required:=False;
          end;
          with AddFieldDef do
          begin
            FieldNo:=6;{AddLink       I   0}
            Name := 'AddLink';
            DataType := ftInteger;
            {Size:=1 ;
            Precision:=1;}
            Required:=False;
          end;
        end;
        { Next, describe any indexes}
        with IndexDefs do
        begin
          Clear;
          { The 1st index has no name because it is
          { a Paradox primary key }
          with AddIndexDef do
          begin
            Name := '';
            Fields := 'Last Name;First Name';
            Options := [ixPrimary];
          end;
          {with AddIndexDef do
          begin
            Name := 'FLink';
            Fields := 'FamilyLink';
            Options := [ixUnique];
          end;}
        end;
        {with IndexDefs.AddIndexDef do begin
            Name := 'FLink';
            Fields := 'FamilyLink';
            Options := [];
        end;}
         {IndexDefs.Add('FLink', 'FamilyLink', []);}
        CreateTable;
        Application.ProcessMessages;
{        FakeDb.Active := True;}
{        FakeDb.Active := False;}
{        FakeDb.AddIndex('FLink', 'FamilyLink',[]);}
      end;
      {Next one}
{  ( Fmlyimag.DB: Table1-DataSource1: MasterSource DataSource2)}
      with FakeDb do
      begin
        { The Table component must not be active }
        Active := False;
        { First, describe the type of table and give }
        { it a name }
        DatabaseName := 'ILH';
        TableType := ttParadox;
        TableName:=DbPath+DBFileName + 'Imag.db';
        { Next, describe the fields in the table }
{showmessage(VRMDatabase+DBFileName + 'imag.db');}
        with FieldDefs do
        begin
          Clear;
{ftAutoInc ftString  ftInteger ftBlob  ftMemo ftGraphic ftBoolean}
(*
  (ImageLink   I key  (This is a key so NO duplicates)
 Fname       A30
  DirName    A200
  Type         A6
  Date       A10   0
  LatY N           90
  LonX N           180
  Direction I       360
  CommonName A30
  Notes      M 10
  BLOBIMAGE  B
*)
          with AddFieldDef do
          begin
            {FieldNo:=1;}{(ImageLink   + key  autoincrement}
            Name := 'ImageLink';
            DataType := ftAutoInc;
            {Size:=20 ;
            Precision:=20; }
            Required:=True;
          end;
          with AddFieldDef do
          begin
            {FieldNo:=2;}{Name       A200}
            Name := 'Name';
            DataType := ftString;
            Size:=200;
            {Precision:=20;}
            Required:=True;
          end;
          with AddFieldDef do
          begin
            {FieldNo:=3;}{Type       A6}
            Name := 'Type';
            DataType := ftString;
            Size:=6 ;
            {Precision:=1;
            Required:=False;}
          end;
          with AddFieldDef do
          begin
            {FieldNo:=4;}{Date       A10   0}
            Name := 'Date';
            DataType := ftString;
            Size:=10 ;
            {Precision:=1;
            Required:=False;}
          end;
          with AddFieldDef do
          begin
            {FieldNo:=5;}{Time       A10   0}
            Name := 'Time';
            DataType := ftString;
            Size:=10 ;
            {Precision:=1;
            Required:=False;}
          end;
          with AddFieldDef do
          begin
            {FieldNo:=6;}{CommonName A30}
            Name := 'CommonName';
            DataType := ftString;
            Size:=30 ;
            {Precision:=1;
            Required:=False;}
          end;
          with AddFieldDef do
          begin
            {FieldNo:=7;}{Notes      M 10}
            Name := 'Notes';
            DataType := ftMemo;
            Size:=10 ;
            {Precision:=1;
            Required:=False;}
          end;
          with AddFieldDef do
          begin
            {FieldNo:=8;}{BLOBIMAGE  B}
            Name := 'BLOBIMAGE';
            DataType := ftBlob;
            {Size:=1 ;
            Precision:=1;
            Required:=False;}
          end;
        end;
        { Next, describe any indexes
         FieldDefs.Add(Edit3.Text, ftInteger, 0, False);
          { The 1st index has no name because it is
          { a Paradox primary key }
         IndexDefs.Clear;
         IndexDefs.Add('', 'ImageLink', [ixPrimary]);

        {with IndexDefs do
        begin
          Clear;
          with AddIndexDef do
          begin
            Name := '';
            Fields := 'ImageLink';
            Options := [ixPrimary];
          end;
        end;}
        CreateTable;
        FakeDb.Active := True;
      end;
{Fmlylink.db    LinkTable-DataSource3   DataSource2  FamilyLink FLink}

      with FakeDb do
      begin
        { The Table component must not be active }
        Active := False;
        { First, describe the type of table and give }
        { it a name }
        DatabaseName := 'ILH';
        TableType := ttParadox;
        TableName:=DbPath+DBFileName + 'Link.db';
        { Next, describe the fields in the table }
{showmessage(VRMDatabase+DBFileName + 'link.db');}
        with FieldDefs do
        begin
          Clear;
          with AddFieldDef do
          begin
            FieldNo:=1;{ImageLink    I key      ILink}
            Name := 'ImageLink';
            DataType := ftInteger;
           {Size:=20 ;
            Precision:=20;}
            Required:=True;
{ftAutoInc ftString  ftInteger ftBlob  ftMemo ftGraphic ftBoolean}
          end;
          with AddFieldDef do
          begin
            FieldNo:=2;{FamilyLink   I key      FLink}
            Name := 'FamilyLink';
            DataType := ftInteger;
            {Size:=2;
            Precision:=20; }
            Required:=True;
          end;
        end;
        { Next, describe any indexes
         FieldDefs.Add(Edit3.Text, ftInteger, 0, False);
         IndexDefs.Clear;
         IndexDefs.Add('PrimaryIndex', Edit2.Text, NewIndexOptions);    }

        with IndexDefs do
        begin
          Clear;
          { The 1st index has no name because it is
          { a Paradox primary key }
          with AddIndexDef do
          begin
            Name := '';
            Fields := 'ImageLink;FamilyLink';
            Options := [ixPrimary];
          end;
          {with AddIndexDef do
          begin
            Name := 'ILink';
            Fields := 'ImageLink';
            Options := [ixUnique];
          end;
          with AddIndexDef do
          begin
            Name := 'FLink';
            Fields := 'FamilyLink';
            Options := [ixUnique];
          end;}
        end;
        CreateTable;
        FakeDb.Active := True;
      end;

{( FmlyAdr.DB AdrTable-AdrSource}
      with FakeDb do
      begin
        { The Table component must not be active }
        Active := False;
        { First, describe the type of table and give }
        { it a name }
        DatabaseName := 'ILH';
        TableType := ttParadox;
        TableName:=DbPath+DBFileName + 'Adr.db';
        { Next, describe the fields in the table }
{showmessage(VRMDatabase+DBFileName + 'Adr.db');}
        with FieldDefs do
        begin
          Clear;
(*
( FmlyAdr.DB AdrTable-AdrSource
AddLink    I key  (This is a key so NO duplicates)
A#         A5
Address    A30
City       A20
State      A2
Zip       A10
ImageLink  I  //Links Address to an Image (1 used for Label)
EMail    A30
Phone     A10
Born      A10
Died      A10
Sex       L
*)
          with AddFieldDef do
          begin
            FieldNo:=1;{AddLink    I key}
            Name := 'AddLink';
            DataType := ftInteger;
           { Size:=20 ;
            Precision:=20;}
            Required:=True;
{ftAutoInc ftString  ftInteger ftBlob  ftMemo ftGraphic ftBoolean}
          end;
          with AddFieldDef do
          begin
            FieldNo:=2;{A#         A5}
            Name := 'A#';
            DataType := ftString;
            Size:=5;
            {Precision:=20; }
            Required:=True;
          end;
          with AddFieldDef do
          begin
            FieldNo:=3;{Address    A30}
            Name := 'Address';
            DataType := ftString;
            Size:=30 ;
            {Precision:=1;
            Required:=False; }
          end;
          with AddFieldDef do
          begin
            FieldNo:=4;{City       A20}
            Name := 'City';
            DataType := ftString;
            Size:=20 ;
            {Precision:=1;
            Required:=False;  }
          end;
          with AddFieldDef do
          begin
            FieldNo:=5;{State      A2}
            Name := 'State';
            DataType := ftString;
            Size:=2 ;
            {Precision:=1;
            Required:=False; }
          end;
          with AddFieldDef do
          begin
            FieldNo:=6;{Zip)       A10}
            Name := 'Zip';
            DataType := ftString;
            Size:=10 ;
            {Precision:=1;
            Required:=False;}
          end;
        end;
        { Next, describe any indexes
         FieldDefs.Add(Edit3.Text, ftInteger, 0, False);
         IndexDefs.Clear;
         IndexDefs.Add('PrimaryIndex', Edit2.Text, NewIndexOptions);    }

        with IndexDefs do
        begin
          Clear;
          { The 1st index has no name because it is
          { a Paradox primary key }
          with AddIndexDef do
          begin
            Name := '';
            Fields := 'AddLink';
            Options := [ixPrimary];
          end;
        end;
        CreateTable;
        FakeDb.Active := True;
      end;

{FmlySave.DB   AdrSavedTable-AdrSavedSource}
      with FakeDb do
      begin
        { The Table component must not be active }
        Active := False;
        { First, describe the type of table and give }
        { it a name }
        DatabaseName := 'ILH';
        TableType := ttParadox;
        TableName:=DbPath+DBFileName + 'Save.db';
        { Next, describe the fields in the table }
{showmessage(VRMDatabase+DBFileName + 'Save.db');}
        with FieldDefs do
        begin
          Clear;
          with AddFieldDef do
          begin
            FieldNo:=1;{NameName  A45      key}
            Name := 'NameName';
            DataType := ftString;
            Size:=45 ;
           { Precision:=20;  }
            Required:=True;
{ftAutoInc ftString  ftInteger ftBlob  ftMemo ftGraphic ftBoolean}
          end;
          with AddFieldDef do
          begin
            FieldNo:=2;{Address   A45}
            Name := 'Address';
            DataType := ftString;
            Size:=45;
            {Precision:=20;
            Required:=False;}
          end;
          with AddFieldDef do
          begin
            FieldNo:=3;{City      A45}
            Name := 'City';
            DataType := ftString;
            Size:=45 ;
           {Precision:=1;
            Required:=False;}
          end;
          with AddFieldDef do
          begin
            FieldNo:=4;{Image     G  }
            Name := 'Image';
            DataType := ftGraphic;
           { Size:=10 ;
            Precision:=1;
            Required:=False;}
          end;
        end;
        { Next, describe any indexes
         FieldDefs.Add(Edit3.Text, ftInteger, 0, False);
         IndexDefs.Clear;
         IndexDefs.Add('PrimaryIndex', Edit2.Text, NewIndexOptions);    }

        with IndexDefs do
        begin
          Clear;
          { The 1st index has no name because it is
          { a Paradox primary key }
          with AddIndexDef do
          begin
            Name := '';
            Fields := 'NameName';
            Options := [ixPrimary];
          end;
        end;
        CreateTable;
        FakeDb.Active := True;
        FakeDb.Active := False;
      end;{Made db}
  { Initialize MyDbCount early on }
  MyDbCount := 1;
  { Later, create a database component at runtime }
  begin
{    MyDatabase[MyDbCount] := RunTimeDbCreate('MyDb' + IntToStr(MyDbCount), '');}
    {Inc(MyDbCount);}
  end;
(*
    Disconnect;
    LinkTableTableName:=LinkTable.TableName;
    LinkTable.Active := False;
    LinkTable.TableName:='';
      {Make new Indexes}
        LinkTable.DatabaseName :={'MyDb1';}{VRMDatabase;} 'ILH';
        LinkTable.TableType := ttParadox;
        LinkTable.TableName:=VRMDatabase+DBFileName + 'Data.db';
        LinkTable.Exclusive := True;
        LinkTable.Active := True;
        LinkTable.AddIndex('FLink', 'FamilyLink',[]);
       { LinkTable.Active := True;}
        LinkTable.Active := False;
        LinkTable.Exclusive := False;
        FakeDb.TableName:=VRMDatabase+DBFileName + 'Link.db';
        FakeDb.Exclusive := True;
{        FakeDb.Active := True;   }
        FakeDb.AddIndex('ILink', 'ImageLink',[]);
        FakeDb.AddIndex('FLink', 'FamilyLink',[]);
{        FakeDb.Active := False;}
        FakeDb.Exclusive := False;
    LinkTable.TableName:=LinkTableTableName;
*)
    end;{Db not exists so make it}
  end;{select a db}
end;

(*************************************************)
function TDatabaseImporterForm.RunTimeDbCreate(const DatabaseName, SessionName: String): TDatabase;
var
  TempDatabase: TDatabase;
begin
  TempDatabase := nil;
  try
    { If the session exists, make it active; if not, create a new session }
    Sessions.OpenSession(SessionName);
    with Sessions do
      with FindSession(SessionName) do begin
        Result := FindDatabase(DatabaseName);
        if (Result = nil) then begin
          { Create a new database component }
          TempDatabase := TDatabase.Create(Self);

          TempDatabase.DatabaseName := DatabaseName;
          TempDatabase.SessionName := SessionName;
          TempDatabase.KeepConnection := True;
        end;
        Result := OpenDatabase(DatabaseName);
      end;
  except
    TempDatabase.Free;
    raise;
  end;
end;
{ftAutoInc ftString  ftInteger ftBlob  ftMemo ftGraphic ftBoolean}
{  TFieldType = (ftUnknown, ftString, ftSmallint, ftInteger, ftWord,
    ftBoolean, ftFloat, ftCurrency, ftBCD, ftDate, ftTime, ftDateTime,
    ftBytes, ftVarBytes, ftAutoInc, ftBlob, ftMemo, ftGraphic, ftFmtMemo,
    ftParadoxOle, ftDBaseOle, ftTypedBinary, ftCursor, ftFixedChar, ftWideString,
    ftLargeint, ftADT, ftArray, ftReference, ftDataSet, ftOraBlob, ftOraClob,
    ftVariant, ftInterface, ftIDispatch, ftGuid);}


(******************************************************)
(******************************************************)
procedure TDatabaseImporterForm.Open1Click(Sender: TObject);
begin
  OpenDialog.Filter := 'any database|*.db';
  OpenDialog.FileName := '*.DB';
  OpenDialog.InitialDir:=DbPath;
  if OpenDialog.execute then
  begin
    { The table should be closed when changing the database }
    Table1.Active := False;
    try
    { First try to use an alias }
    Table1.DatabaseName := 'ILH';
    Table1.Active := True;
    except
    on EDatabaseError do
    { If that fails, try to use the drive and directory }
    Table1.DatabaseName := ExtractFilePath(OpenDialog.FileName);
    end;
    Table1.TableName := OpenDialog.FileName;
    Table1.Active := True;
    DBFileName:=ExtractFileName(OpenDialog.FileName);
    DbPath:=ExtractFilePath(OpenDialog.FileName);
  end;
end;

   {( Fmlyimag.DB: ImagTable-ImagDS: MasterSource DataSource2)
  (ImageLink   I key
  Name       A200
  Type       A6
  Date       A10   0
  LatY N           90
  LonX N           180
  Direction I       360
  CommonName A30
  Notes      M 10
  BLOBIMAGE  B


(  Fmlydata.DB : DataTable-DataDS
Last Name     A20 key
First Name    A20 key
FamilyLink    I    made upon appending    FLink
ParentLink    F   0  Floating Point       PLink
AddLink       I   0
Spouse        I
Father        I
Mother        I
Rcvd          L    True
Sent          L    True

(FmlyNote.DB : NoteTable-NoteDS)
FamilyLink    I
  Notes      M 1

Fmlylink.db    LinkTable-LinkDS   DataDS  FamilyLink FLink
ImageLink    I key      ILink
FamilyLink   I key      FLink

( FmlyAdr.DB AdrTable-AdrSource
AddLink    I key
A#         A5
Address    A30
City       A20
State      A2
Zip       A10
ImageLink  I  Links Address to an Image
EMail    A30
Phone     A10
Born      A10
Died      A10
Sex       L

FmlySave.DB   AdrSavedTable-AdrSavedSource
NameName  A45      key
Address   A45
City      A45
Image     G   }
(******************************************************)
(******************************************************)

{  OpenDialog2.Filter := 'Family database|*.db';
  OpenDialog2.FileName := '????Data.DB';

  OpenDialog2.Filter := 'Addresses database|*.db';
  OpenDialog2.FileName :=  '????Adr.DB';}

(*
var
  LastNameS, FirstNameS: string;
  LastOneI: Integer;
begin
  Disconnect;
  DataTable.IndexName := 'FLink';
  DataTable.Last;
  LastOneI := DataTableFamilyLink.value;
  inc(LastOneI);
  LastNameS := LastNameEdit.Text;
  FirstNameS := FirstNameEdit.Text;
  DataTable.AppendRecord([LastNameS, FirstNameS,
        LastOneI, 0, 0,0,0, 0, False, False]);

  AdrTable.Last;
  LastOneI := DbSessionForm.AdrTableAddLink.value;
  inc(LastOneI);
  AdrTable.AppendRecord([LastOneI]);
  DataTable.Edit;
  DataTableAddLink.Value := LastOneI;
  DataTable.Post;

  Disconnect;
  DataTable.Refresh;
*)

procedure TDatabaseImporterForm.AppendImportedBtnClick(Sender: TObject);
begin
{Open 2 Databases then append to Data and Adr}
{  OpenDialog2.Filter := 'Family database|*.db';
  OpenDialog2.FileName := '????Data.DB';

  OpenDialog2.Filter := 'Addresses database|*.db';
  OpenDialog2.FileName :=  '????Adr.DB';}
end;



end.
