unit DbSecretFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, Printers,
  Grids, DBGrids, ExtCtrls, DBCtrls, Db, DBTables, Menus;

type
  TSecretDbForm = class(TForm)
    MainMenu1: TMainMenu;
    OpenFile: TMenuItem;
    Help1: TMenuItem;
    Exit1: TMenuItem;
    DataSource1: TDataSource;
    Table1: TTable;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    OpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure OpenFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SecretDbForm: TSecretDbForm;
  DBFileName:String;

implementation

{$R *.DFM}

uses TongGlobals;

procedure TSecretDbForm.FormCreate(Sender: TObject);
begin
  top := SecretDbFormY;
  left := SecretDbFormX;
end;

procedure TSecretDbForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SecretDbFormY := SecretDbForm.top;
  SecretDbFormX := SecretDbForm.left;
  DoSaver;
  Table1.Active := False;
  Table1.TableName :='';
  Table1.DatabaseName :='';
end;

procedure TSecretDbForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TSecretDbForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(9400);
end;

procedure TSecretDbForm.OpenFileClick(Sender: TObject);
begin
  OpenDialog.Filter := 'any database|*.db';
  OpenDialog.FileName := '*.DB';
  OpenDialog.InitialDir:=DbPath;
  if OpenDialog.execute then
  begin
    { The table should be closed when changing the database }
    Table1.Active := False;
    try
    { First try to use an alias }
    Table1.DatabaseName := 'ILH';
    Table1.Active := True;
    except
    on EDatabaseError do
    { If that fails, try to use the drive and directory }
    Table1.DatabaseName := ExtractFilePath(OpenDialog.FileName);
    end;
    Table1.TableName := OpenDialog.FileName;
    Table1.Active := True;
    DBFileName:=ExtractFileName(OpenDialog.FileName);
    DbPath:=ExtractFilePath(OpenDialog.FileName);
  end;
end;

end.
