unit ImageTypeConverterFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  jpg, jpeg, PNGImage,
  StdCtrls, ExtCtrls, Buttons, FileCtrl, ComCtrls;

type
  TImageTypeConverterForm = class(TForm)
    OpenDialog: TOpenDialog;
    Panel1: TPanel;
    DriveComboBox1: TDriveComboBox;
    Label2: TLabel;
    DirectoryListBox1: TDirectoryListBox;
    DirLabel: TLabel;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    MinEdit: TEdit;
    Label3: TLabel;
    MaxEdit: TEdit;
    DirectoryEdit: TEdit;
    MinMaxCB: TCheckBox;
    TypeRG: TRadioGroup;
    SelectBtn: TSpeedButton;
    ConvertSameCB: TCheckBox;
    CancelBtn: TSpeedButton;
    StatusLabel: TLabel;
    HelpBtn: TSpeedButton;
    CloseBtn: TSpeedButton;
    Panel2: TPanel;
    SkipRichEdit: TRichEdit;
    Splitter1: TSplitter;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure SelectBtnClick(Sender: TObject);
    procedure SkipRichEditMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    CancelConversion:Boolean;
  public
    { Public declarations }
  end;

var
  ImageTypeConverterForm: TImageTypeConverterForm;

implementation
uses
  JPEG_IO, {Intel jpg dll... only for saving at moment reads using jpeg}
  TongGlobals;
{$R *.DFM}

procedure TImageTypeConverterForm.FormCreate(Sender: TObject);
begin
 CancelConversion:=False;
end;
procedure TImageTypeConverterForm.FormShow(Sender: TObject);
begin
  left := ITCFormX;
  top := ITCFormY;
end;

procedure TImageTypeConverterForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(8888);
end;
procedure TImageTypeConverterForm.CloseBtnClick(Sender: TObject);
begin
  close;
end;
procedure TImageTypeConverterForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ITCFormX := ImageTypeConverterForm.left;
  ITCFormY:= ImageTypeConverterForm.top;
end;

procedure TImageTypeConverterForm.SpeedButton1Click(Sender: TObject);
begin
  CreateDir(DirLabel.Caption+'\'+DirectoryEdit.text);
end;

procedure TImageTypeConverterForm.CancelBtnClick(Sender: TObject);
begin
  CancelConversion:=True;
end;

procedure TImageTypeConverterForm.SelectBtnClick(Sender: TObject);
var
   f: file of Byte;
   size : Longint;
  PNG:TPNGObject;
  jp: TJpegImage;
  Tempbmp: TBitmap;
  MinSize,MaxSize, toobig,i:Integer;
  Starttime,endtime:TDateTime;
  Hour, Min, Sec, MSec: Word;
 TempPath, TempFilename2, TempFilename : String;
begin  {[ofHideReadOnly,ofEnableSizing]}
  OpenDialog.Options := [ofAllowMultiSelect, ofFileMustExist];
  OpenDialog.InitialDir := ImagePath;
  OpenDialog.Filter := 'All (*.bmp;*.png;*.jpg)|*.bmp;*.png;*.jpg|png|*.png|jpeg|*.jpg|bitmap|*.bmp';
  if OpenDialog.Execute then
  begin
    SkipRichEdit.Clear;
    CancelConversion:=False;
    ImagePath:=Extractfilepath(OpenDialog.Filename);
    {PNG := TPNGObject.Create;
    jp := TJpegImage.Create;
    Tempbmp:= TBitmap.Create;}
    toobig:=0;
    MinSize:= Strtoint(MinEdit.Text);
    MaxSize:= Strtoint(MaxEdit.Text);
    TempPath:=DirLabel.Caption+'\';
    Starttime:=Now;
    Screen.Cursor := crHourGlass;
    StatusLabel.Caption :=Inttostr(MinSize);{Just to do it}
    Application.ProcessMessages;
    try
      with OpenDialog.Files do
      for I := 0 to Count - 1 do
      begin
        TempFilename:= Strings[I];  { next file in Files property }
        AssignFile(f, TempFilename);
        Reset(f);
        size := FileSize(f);
        CloseFile(f);
        If ((not MinMaxCB.Checked) or
        ((size > MinSize)and (size < MaxSize))) then
        begin
          If CancelConversion then exit;
          StatusLabel.Caption :=
            Inttostr(i+1)+ ' of '+Inttostr(Count);
          Application.ProcessMessages;
          {Load the image}
          if (lowercase(extractfileext(TempFilename)) = '.bmp') then
          begin
            {jp := TJpegImage.Create;}
            Tempbmp:= TBitmap.Create;
            PNG := TPNGObject.Create;
            try
              Case TypeRG.ItemIndex of
                0:If ConvertSameCB.Checked then
                Begin
                  Tempbmp.LoadFromFile(TempFilename);
                  TempFilename2:=TempPath+
                     Extractfilename(ChangeFileExt(TempFilename,'.bmp'));
                  Tempbmp.SaveToFile(TempFilename2);
                End;
                1:
                Begin
                  Tempbmp.LoadFromFile(TempFilename);
                  {PNG := TPNGObject.Create;}
                  PNG.Assign(Tempbmp);
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.png'));
                  PNG.SaveToFile(TempFilename2);
                  {PNG.Free;}
                end;
                2:
                begin
                  Tempbmp.LoadFromFile(TempFilename);
        If IntelJpgAvailable then
        begin
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.jpg'));
          SaveBmpToJpegFile (
          Tempbmp,
          TempFilename2,
          JpgQuality,
          jpgComments);
        end else
        begin
                  jp := TJpegImage.Create;
                  try
                  jp.Assign(Tempbmp);
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.jpg'));
                  jp.SaveToFile(TempFilename2);
                  finally jp.Free; end;
                  end;
                end;
              end;{case}
            finally
               PNG.Free;
               {jp.Free;}
               Tempbmp.Free;
            end;
          end else
          if (lowercase(extractfileext(TempFilename)) = '.jpg') then
          begin
            jp := TJpegImage.Create;
            Tempbmp:= TBitmap.Create;
            PNG := TPNGObject.Create;
            try
              If TypeRG.ItemIndex =0 then
              begin
                with jp do
                begin
                  jp.LoadFromFile(TempFilename);
                  Tempbmp.Assign(jp);
                  {jp.Free;}
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.bmp'));
                  Tempbmp.SaveToFile(TempFilename2);
                end;
              end else
              If TypeRG.ItemIndex =1 then
              begin
                with jp do
                begin
                  jp.LoadFromFile(TempFilename);
                  Tempbmp.Assign(jp);
                  {jp.Free;}
                  PNG.Assign(Tempbmp);
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.png'));
                  PNG.SaveToFile(TempFilename2);
                end;
              end else
              If TypeRG.ItemIndex =2 then
              begin
                If ConvertSameCB.Checked then
                with jp do
                begin
                  jp.LoadFromFile(TempFilename);
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.jpg'));
                  jp.SaveToFile(TempFilename2);
                end;
              end;
            finally
               PNG.Free;
               jp.Free;
               Tempbmp.Free;
            end;
          end else
          if (lowercase(extractfileext(TempFilename)) = '.png') then
          begin
            Tempbmp:= TBitmap.Create;
            PNG := TPNGObject.Create;
            try
              If TypeRG.ItemIndex =0 then
              begin
                begin
                  png.LoadFromFile(TempFilename);
                  Tempbmp.Assign(png);
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.bmp'));
                  Tempbmp.SaveToFile(TempFilename2);
                end;
              end else
              If TypeRG.ItemIndex =1 then
              begin
                If ConvertSameCB.Checked then
                begin
                  png.LoadFromFile(TempFilename);
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.png'));
                  png.SaveToFile(TempFilename2);
                end;
              end else
              If TypeRG.ItemIndex =2 then
              begin
        If IntelJpgAvailable then
        begin
                  png.LoadFromFile(TempFilename);
                  Tempbmp.Assign(png);
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.jpg'));
          SaveBmpToJpegFile (
          Tempbmp,
          TempFilename2,
          JpgQuality,
          jpgComments);
        end else
        begin
                jp := TJpegImage.Create;
                try
                with jp do
                begin
                  png.LoadFromFile(TempFilename);
                  Tempbmp.Assign(png);
                  {PNG.Free;}
                  jp.Assign(Tempbmp);
                  TempFilename2:=TempPath+
                  Extractfilename(ChangeFileExt(TempFilename,'.jpg'));
                  jp.SaveToFile(TempFilename2);
                end;
                finally
                  jp.Free;
                end;
                end;
              end;
            finally
              PNG.Free;
              Tempbmp.Free;
            end;
          end;
        end else
        begin
          SkipRichEdit.Lines.Add(Extractfilename(TempFilename));
          inc(toobig);
        end;
      end ;
    finally
      {PNG.Free;
      jp.Free;
      Tempbmp.Free;}
      endtime:=Now;
      DecodeTime(endtime-Starttime, Hour, Min, Sec, MSec);
      StatusLabel.Caption :=
                 IntToStr(Hour)+' H '
               + IntToStr(Min)+' M '
               + IntToStr(Sec)+' S '
               + IntToStr(MSec)+' MS';
      SkipRichEdit.Lines.Add('Skipped: too big: '+Inttostr(toobig));
      SkipRichEdit.Lines.Add(
                 IntToStr(Hour)+' H '
               + IntToStr(Min)+' M '
               + IntToStr(Sec)+' S '
               + IntToStr(MSec)+' MS');
      Screen.Cursor := crDefault;
      OpenDialog.Options := [ofHideReadOnly,ofEnableSizing];
    end;
  end;
end;



procedure TImageTypeConverterForm.SkipRichEditMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SkipRichEdit.SelectAll;
  SkipRichEdit.CopyToClipboard;
end;

end.
