unit PicAbout;

interface

uses
  Windows, Classes, Sysutils,
  Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TPicAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    ZDImage1: TImage;
    AllLabel: TLabel;
    PicLabel1: TLabel;
    Comments: TLabel;
    PicLabel2: TLabel;
    MyButton: TButton;
    ShowImage: TImage;
    GrexImage: TImage;
    Image5: TImage;
    janLabel1: TLabel;
    janLabel2: TLabel;
    G32Panel: TPanel;
    GrafreeLabel: TLabel;
procedure Init(Input:Integer);
    procedure MyButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CommentsClick(Sender: TObject);
    procedure GrafreeLabelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PicAboutBox: TPicAboutBox;

implementation
uses TongGlobals;
{$R *.DFM}

procedure TPicAboutBox.Init(Input:Integer);
const
  product_name1 = 'David''s ShowMan program';
  product_version1 = 'Version 2.0.4';
  product_copyright1 = 'Copyright '#169' David J Taylor, Edinburgh, 1993-1996';
  product_comments1 = 'http://www.david-taylor.pwp.blueyonder.co.uk/';

  product_name2 = 'PicAlbum';
  product_version2 = 'Version 1.0';
  product_copyright2 ='Copyright 1995  Ziff-Davis Publishing Company';
  product_comments2 = 'Author Michael J. Mefford';
{    PicLabel1.Caption :='First appeared in PC Magazine, US Edition';
    PicLabel2.Caption :='April 9, 1996';}

  product_name3 = 'GraphicEx';
  product_version3 = 'Version 9';
  product_copyright3 = 'Copyright 2003  Dipl. Ing. Mike Lischke';
  product_comments3 = 'http://www.lischke-online.de';
{eMail:	public@lischke-online.de (general support)
	shareware@lischke-online.de (registered users)  }
{TPNGImage version 1.2 Gustavo Huffenbacher Daud
all else unknown}
{BMP to TIFF  version 3.0 - Sep 10, 2000
Copyright (c) 2000, Wolfgang Krug}

  product_name4 = 'TBTFileFinder class'+'08.01.1999';
  product_version4 = 'Version 0.01';
  product_copyright4 = 'Copyright 2001  Theodoros Bebekis';
  product_comments4 = 'mailto: bebekis@otenet.gr';
{    PicLabel1.Caption :='David Taylor, Edinburgh, 1996'
    PicLabel2.Caption :='WinTidy: david.taylor@gecm.com';}
{David Taylor, Edinburgh, 1996
david.taylor@gecm.com
WinTidy - Delphi 2.0 32 bit version
   *.tmp    ~*.*     *.~*     *.?~?
   *.aps    *.bak    *.bk?    *.bsc
   *.dmp    *.dsm    *.ilk    *.pch
   *.rws    *.sbr    *.$$$    backup*.wbk
.FTS and .GID}

  product_name5 = 'TPreview';
  product_version5 = 'version 3.0';
  product_copyright5 = 'Copyright  1991..2002 by Rustam Kafarov';
  product_comments5 = 'http://www.kafarov.f2s.com/';

  product_name6 = 'gfx Effect Affects';
  product_version6 = 'GFX_LIBRARY v1.2 beta';
  product_copyright6 = 'Copyright 2001  Andreas Moser';
  product_comments6 = 'mailto: amoser@amoser.de';

 product_name7 = 'Graphics32';
  product_version7 = 'version v1.0';  {alex@g32.org}
  product_copyright7 = 'Copyright  2000-2003 Alex A. Denisov';
  product_comments7 = 'http://g32.org/index.html';

 product_name8= 'Jan Shape';
  product_version8 = 'version v1.0';  {Jan Verhoeven}
  product_copyright8 = 'Copyright  2000-2001 Jan Verhoeven';
  product_comments8 = 'http://jansfreeware.com/freeware.htm';


  product_name10 = 'Tongs';
  product_version10 = 'Version 1.0';
  product_copyright10 = 'Copyright 2004  by Ivan Lee Herring';
  product_comments10 = 'http://www.ezl.com/~ilh2o/';

begin
    ShowImage.Visible:=False;{1}
    ZDImage1.Visible:=False; {2}
    ProgramIcon.Visible:=False;{ZD too}
    GrexImage.Visible:=False;{3}
    {no #4 icon}
    Image5.Visible:=False;{5 + 10... Grafree}
    janLabel1.Visible:=False;{6}
    janLabel2.Visible:=False;
    G32Panel.Visible:=False;{7}
    MyButton.Caption:= Application.Title+ ' combined by Ivan Lee Herring,  2004';
  case Input of
  1:begin   {ShowMan}
    PicLabel1.Caption :='Delphi 5.0 - 32-bit version';
    PicLabel2.Caption :='';
    ProductName.Caption := product_name1;
    Version.Caption := product_version1;
    Copyright.Caption := product_copyright1;
    Comments.Caption := product_comments1;
    ShowImage.Visible:=true;
  end;
  2:begin {TPicMainForm}
    PicLabel1.Caption :='First appeared in PC Magazine, US Edition';
    PicLabel2.Caption :='April 9, 1996';
    ProductName.Caption := product_name2;
    Version.Caption := product_version2;
    Copyright.Caption := product_copyright2;
    Comments.Caption := product_comments2;
    ZDImage1.Visible:=true;
    ProgramIcon.Visible:=true;
  end;
  3:begin {GraphicEx}
{TPNGImage version 1.2 Gustavo Huffenbacher Daud
all else unknown}
{BMP to TIFF  version 3.0 - Sep 10, 2000
Copyright (c) 2000, Wolfgang Krug}
{PicLabel1.Left:=10; }
    PicLabel1.Caption :='TPNGImage version 1.4 Gustavo Huffenbacher Daud';
{PicLabel2.Left:=10;}
    PicLabel2.Caption :='BMP to TIFF  version 3.0 - Sep 10, 2000'
           +#13+#10+    'Copyright (c) 2000, Wolfgang Krug';
    ProductName.Caption := product_name3;
    Version.Caption := product_version3;
    Copyright.Caption := product_copyright3;
    Comments.Caption := product_comments3;
    GrexImage.Visible:=true;
  end;
  4:begin {WinTidy TBTFileFinder}
    PicLabel1.Caption :='WinTidy: David Taylor, Edinburgh, 1996';
    PicLabel2.Caption :='mailto: davidtaylor@writeme.com';
    ProductName.Caption := product_name4;
    Version.Caption := product_version4;
    Copyright.Caption := product_copyright4;
    Comments.Caption := product_comments4;
    janLabel1.Caption :='Ben Ziegler  Disk Hog';
    janLabel2.Caption :='http://www.radix.net/~bziegler/Delphi';
    janLabel1.Visible:=true;
    janLabel2.Visible:=true;
    ShowImage.Visible:=true;
{    GrexImage.Visible:=true;}
  end;
  5:begin {efg2lab }
    PicLabel1.Caption :='adapted from efg Slide Show';
    PicLabel2.Caption :='Copyright 2004  efg Computer Lab';
    janLabel1.Caption :='http://homepages.borland.com/efg2lab/';
    janLabel1.Visible:=true;
    ProductName.Caption := product_name5;
    Version.Caption := product_version5;
    Copyright.Caption := product_copyright5;
    Comments.Caption := product_comments5;
    Image5.Visible:=true;
  end;
  6:begin {gfx +jans}
    PicLabel1.Caption :='Phil  Francesco Savastano 2000';
    PicLabel2.Caption :='http://digilander.iol.it/gensavas/francosava/';
    ProductName.Caption := product_name6;
    Version.Caption := product_version6;
    Copyright.Caption := product_copyright6;
    Comments.Caption := product_comments6;
    Image5.Visible:=true;
    janLabel1.Caption :='janFX  by Jan Verhoeven 2-july-2000';
    janLabel2.Caption :='http://jansfreeware.com/freeware.htm';
    janLabel1.Visible:=true;
    janLabel2.Visible:=true;
  end;

  7:begin {alex@g32.org}
    PicLabel1.Caption :='';
    PicLabel2.Caption :='alex@g32.org';
    ProductName.Caption := product_name7;
    Version.Caption := product_version7;
    Copyright.Caption := product_copyright7;
    Comments.Caption := product_comments7;
    G32Panel{Image5}.Visible:=true;
  end;
  8:begin {gfx +jans}
    PicLabel1.Caption :='';
    PicLabel2.Caption :='';
    ProductName.Caption := product_name8;
    Version.Caption := product_version8;
    Copyright.Caption := product_copyright8;
    Comments.Caption := product_comments8;
    Image5.Visible:=true;
    janLabel1.Caption :='janFX  by Jan Verhoeven 2-july-2000';
    janLabel2.Caption :='http://jansfreeware.com/freeware.htm';
    janLabel1.Visible:=true;
    janLabel2.Visible:=true;
  end;
 10.. 13:begin {mine}
    PicLabel1.Caption :='';
    PicLabel2.Caption :='';
    If Input=11 then
    begin
    PicLabel1.Caption :='GLScene (egg) AVIRecorder by Nelson Chu';
    PicLabel2.Caption :='vfw trans by Ronald Dittrich http://www.swiftsoft.de/';
    end;
    If Input=12 then
    begin
    PicLabel1.Caption :='Aviloader Copyright (c) 1995. - 2000. HydroS Co.';
    PicLabel2.Caption :='http://hydros.8k.com/';
    end;
    If Input=13 then
    begin
    PicLabel1.Caption :='TPreview 3.0 Copyright  2002 by Rustam Kafarov';
    PicLabel2.Caption :='http://www.kafarov.f2s.com/';
    end;
    ProductName.Caption := product_name10;
    Version.Caption := product_version10;
    Copyright.Caption := product_copyright10;
    Comments.Caption := product_comments10;
    Image5.Visible:=true;
  end;
end;{case}
end;

procedure TPicAboutBox.MyButtonClick(Sender: TObject);
begin
Close;
end;

procedure TPicAboutBox.FormCreate(Sender: TObject);
begin
  top := PicAboutBoxY;
  left := PicAboutBoxX;
end;

procedure TPicAboutBox.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  PicAboutBoxX := PicAboutBox.left;
  PicAboutBoxY := PicAboutBox.top;
end;

procedure TPicAboutBox.CommentsClick(Sender: TObject);
begin
  ExecuteFile(  {  ShellExecute(0, 'open',}
  Comments.Caption{'http://www.ezl.com/~ilh2o/'},
  '', '',SW_SHOWNORMAL);
end;

procedure TPicAboutBox.GrafreeLabelClick(Sender: TObject);
begin
  ExecuteFile(
  {  ShellExecute(0, 'open',}
  {'http://www.ezl.com/~ilh2o/'}
    extractfilepath(paramstr(0))+'tongs.html',
     '', '',SW_SHOWNORMAL);
end;

end.

