unit PngInfoFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,pngimage,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TPngInfoForm = class(TForm)
    RichEdit1: TRichEdit;
    OpenDialog1: TOpenDialog;
    ListBox1: TListBox;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    SpeedButton2: TSpeedButton;
    Splitter1: TSplitter;
    SpeedButton3: TSpeedButton;
    SaveDialog1: TSaveDialog;
    SpeedButton4: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
    png: TPngObject;
  public
    { Public declarations }
  end;

var
  PngInfoForm: TPngInfoForm;

implementation
uses TongGlobals;
{$R *.DFM}

procedure TPngInfoForm.FormCreate(Sender: TObject);
begin
 { inherited Create(AOwner);}
  png := tpngobject.create;
  left := PngInfoFormX;
  top := PngInfoFormY;
end;

procedure TPngInfoForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  PngInfoFormX := PngInfoForm.left;
  PngInfoFormY := PngInfoForm.top;
end;

procedure TPngInfoForm.FormDestroy(Sender: TObject);
begin
  {inherited Destroy; }
  png.free;
end;

procedure TPngInfoForm.SpeedButton1Click(Sender: TObject);
var
  i: Integer;
begin
  OpenDialog1.InitialDir:=ImagePath;
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);
    Edit1.Text:=OpenDialog1.FileName;
    Application.ProcessMessages;
  try
    {Load the png file into the object}
    png.LoadFromFile(Edit1.Text);
    {Clear the listbox}
    listbox1.items.clear;
    RichEdit1.clear;
    {Searches for all the chunks using the type TChunktEXt}
    {add these to the listbox and a pointer to the chunk}
    {Note that all textual chunks are descendent from 
    {TChunktEXt}
    for i := 0 to png.chunks.count - 1 do
      if png.chunks.item[i] is TChunktEXt then
        listbox1.Items.AddObject(TChunktEXt(
          png.chunks.item[i]).keyword, png.chunks.item[i]);
  except
    {In case the image could not be loaded, show error}
    showmessage('The file could not be loaded.');
  end;
  end;
end;

procedure TPngInfoForm.SpeedButton3Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
     RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TPngInfoForm.SpeedButton2Click(Sender: TObject);
begin
close;
end;

procedure TPngInfoForm.ListBox1Click(Sender: TObject);
begin
  if listbox1.itemindex <> -1 then
    RichEdit1.text := TChunktEXt(
      Listbox1.Items.Objects[Listbox1.itemindex]).Text;
end;

procedure TPngInfoForm.SpeedButton4Click(Sender: TObject);
begin
    Application.HelpContext(230);
end;

end.
