unit TPrefrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,JPEG, PNGImage,GraphicEx,
  ExtCtrls, StdCtrls, FileCtrl, Spin, Db, DBTables, ComCtrls, Buttons;

type
  TTPreForm = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Table1: TTable;
    Panel1: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Edit2: TEdit;
    UpDown2: TUpDown;
    DCBPanel: TPanel;
    DriveComboBox1: TDriveComboBox;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    HelpBtn: TSpeedButton;
    ProgressBar1: TProgressBar;
    StopBtn: TSpeedButton;
    Image2: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
procedure RefreshAll;    
    procedure UpDown2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
procedure LoadOneImage;
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure DCBPanelResize(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
  private
  StopProcessing:Boolean;
  procedure refreshicons;
  procedure leggidim(var icondim:integer);
  procedure aggiorna;
  procedure aggiorna1(var dim:integer);
  procedure createthumbsdb;
  procedure deletethumbsdb;
  procedure updatethumbsdb;
    { Private declarations }
  public
    { Public declarations }
{procedure CreateThumbnail(const InFileName, OutFileName: string;
  Width, Height: Integer; FillColor: TColor=clWhite);}

{Function FetchaThumb(InFileName: string):TBitmap;}
procedure AddOneImage(MyFileName: string);
{procedure CreateThumbsAlbum;}
  end;


var
  TPreForm: TTPreForm;
  Thumbsactive:Boolean;

implementation

uses Tongsfrm, TongGlobals;

{$R *.DFM}

{All graphics|*.bmp;*.dib;*.ico;*.jpg;*.jpeg;*.emf;*.wmf;*.sgi;*.bw;*.rgb;*.rgba;*.png;*.psp;*.pcd;*.tif;*.tiff;*.eps;*.tga;*.vst;*.icb;*.vda;*.win;*.pcx;*.pcc;*.scr;*.psd;*.pdd;*.rla;*.rpf;*.ppm;*.pgm;*.pbm;*.cut;*.pal;*.cel;*.pic;}
procedure TTPreForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  TPreFormX := TPreForm.left;
  TPreFormY := TPreForm.top;
end;

procedure TTPreForm.FormCreate(Sender: TObject);
begin
Thumbsactive:=false;
with table1.fielddefs do begin
clear;
add ('Name',ftstring,200,true);
add ('Type',ftstring,6,false);
add ('Date',ftstring,10,false);
add ('Time',ftstring,10,false);
add ('Image',ftgraphic,0,false);
end;
table1.indexdefs.add('Name1','Name',[ixprimary]);
end;
{Common_Name 30    Notes  10 ftMemo    Graphic ftBlob  }
procedure TTPreForm.FormShow(Sender: TObject);
begin
  top := TPreFormY;
  left := TPreFormX;
  StopProcessing:=False;
  DirectoryListBox1Change(Self);
end;
procedure TTPreForm.DCBPanelResize(Sender: TObject);
begin
  DriveComboBox1.Width:=DCBPanel.Width-2;
  DriveComboBox1.Height:=DCBPanel.Height-2;
end;

procedure TTPreForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(4567);
end;




procedure tTPreForm.updatethumbsdb;
var
dim:integer;
var DbName:String;
begin
  {DbName :=ThumbPath+'\'+filelistbox1.directory+ '.db';}
  DbName :=ExtractFileName(filelistbox1.directory+ '.db');
  DbName :=ThumbPath+'\'+DbName;
                            {thumbs}
  if fileexists(DbName)then
  begin
    aggiorna;
    table1.first;
    leggidim(dim);
    aggiorna1(dim);
  end
end;


procedure tTPreForm.aggiorna;
var
i{,tot}:integer;
begin
  with table1 do
  begin
    first;
    i:=1;
    while i<= recordcount do
    begin
      recno:=i;           {DB name}
      if (not fileexists(filelistbox1.Directory+'\'+fields[0].asstring))then
      delete
      else
      i:=i+1;
    end;
  end;
end;


procedure tTPreForm.leggidim(var icondim:integer);
var
blob:tbitmap;
begin
  blob:=tbitmap.create;
  try
    blob.Assign(tblobfield(table1.fieldbyname('Image')));
    except;
  end;
  if blob.width>blob.height then
     icondim:=blob.width
     else icondim:=blob.height;
  blob.free;
  If (icondim<> Thumbsize) then
  begin
    deletethumbsdb;
    Thumbsactive:=False;
    icondim:= Thumbsize;
    createthumbsdb;
  end;
end;

procedure tTPreForm.aggiorna1(var dim:integer);
var
  i,tot:integer;
  MyFileName,compara,Date,Time:string;
  test:boolean;
  myhandle:thandle;
begin
  if dim>0 then
  begin
    with table1 do
    begin
      tot:=filelistbox1.items.Count-1;
      first;
      for i:=tot downto 0 do
      begin
        compara:=extractfilename(filelistbox1.items[i]);
        if extractfileext(compara)<>'' then
        begin
          test:=findkey([compara]);
          myhandle:=fileopen(filelistbox1.directory+'\'+extractfilename(filelistbox1.items[i]),fmopenread);
          Date:=datetostr(filedatetodatetime(filegetdate(myhandle)));
          Time:= timetostr(filedatetodatetime(filegetdate(myhandle)));
          fileclose(myhandle);
          if (not  test)
              or(test and (fieldbyname('Date').asstring<>Date))
              or(test and (fieldbyname('Time').asstring<>Time)) then
          begin
            MyFileName:=filelistbox1.Directory+'\'+compara;
            if test then Delete;
            AddOneImage(MyFileName);
            table1.refresh;
          end;
        end;
      end;
    end;
  end;
end;

procedure TTPreForm.StopBtnClick(Sender: TObject);
begin
  StopProcessing:=True;
end;
procedure TTPreForm.Button1Click(Sender: TObject);
begin
  createthumbsdb;
  If StopProcessing then
  begin
    deletethumbsdb;
    RefreshAll;
    ProgressBar1.Position:=0;
    screen.cursor:=crdefault;
    HelpBtn.Caption:='?';
  end;
end;
procedure tTPreForm.createthumbsdb;
var
  DbName:string;
  lista:tstringlist;
  i:integer;
begin
  screen.cursor:=crhourglass;
  StopProcessing:=False;
  Thumbsactive:=False;
  with table1 do
  begin
    if filelistbox1.items.count>0 then
    begin
      HelpBtn.Caption:='Create';
      lista:=tstringlist.create;
      for i:=0 to filelistbox1.items.count-1 do
      lista.Add(filelistbox1.directory+'\'+filelistbox1.items[i]);
      active := false ;
      databasename :=ThumbPath;
      DbName :=ExtractFileName(filelistbox1.directory+ '.db');
      tablename :=ThumbPath+'\'+DbName;
      tabletype := ttparadox ;
      createtable;
      active:=true;
      cancel;
      ProgressBar1.Position:=0;
      for i:=0 to lista.Count-1 do
      begin
        ProgressBar1.Position:= Round((i/lista.Count )*100);
        Application.ProcessMessages;
        AddOneImage(lista.Strings[i]);
        If StopProcessing then exit;
      end;
      ProgressBar1.Position:=0;
      screen.cursor:=crdefault;
      lista.free;
    end;
  end;
  if filelistbox1.items.count>0 then
     refreshicons
  else image1.picture.Assign(nil);
  HelpBtn.Caption:='?';
end;


procedure tTPreForm.refreshicons;
var
i:integer;
alt,larg,{larg1,alt1,}ncol,nrow:integer;
bit:tbitmap;
nicone:integer;
icona:tbitmap;
npag:integer;
fine:integer;
xpos,ypos:integer;
TempName,DbName:String;
iwidth,iheight:integer;
icondim:integer;
begin
  screen.cursor:=crhourglass;
  HelpBtn.Caption:='Refresh';
  with table1 do
  begin
    active:=false;
    databasename :=ThumbPath;
    DbName :=ExtractFileName(filelistbox1.directory+ '.db');
    tablename :=ThumbPath+'\'+DbName; {thumbs}
    tabletype := ttparadox ;
    active:=true;
  end;
  npag:=updown2.position;
  larg:=scrollbox1.width;
  alt:=scrollbox1.height;
  icondim:=ThumbSize;{updown1.position;}
  ncol:=larg div icondim ;
  nrow:=alt div icondim;
  if ncol<=0 then ncol:=1;
  if nrow<=0 then nrow:=1;
  nicone:=ncol*nrow;
  bit:=tbitmap.create;
  bit.PixelFormat:=pf24bit;
  bit.width:=ncol*icondim;
  bit.height:=nrow*icondim;
  fine:=nicone*npag;
  if fine>=table1.recordcount then
  fine:=table1.recordcount;
  xpos:=0;
  ypos:=0;
  ProgressBar1.Position:=0;
  for i:=nicone*(npag-1)+1 to fine do
  begin
    ProgressBar1.Position:= Round((1 /fine )*100);
    Application.ProcessMessages;
    table1.RecNo:=i;
    icona:=tbitmap.create;
    icona.Assign(table1.fieldbyname('Image')) ;
    if icona.width>=icona.height then
    begin
      iwidth:=icondim-10;
      iheight:=round(iwidth*icona.height/icona.width);
    end
    else
    begin
      iheight:=icondim-10;
      iwidth:=round(iheight*icona.width/icona.height);
    end;
    bit.canvas.StretchDraw(
        rect(xpos+(icondim-iwidth)div 2,
             ypos+(icondim-iheight)div 2,
             xpos+(icondim-iwidth)div 2+iwidth,
             ypos+(icondim-iheight)div 2+iheight),
       icona);
    {Label each image}
    TempName:= table1.fieldbyname('Name').asstring;
    bit.canvas.Textout(xpos+(icondim-iwidth)div 2,
                   ypos+(icondim-iheight)div 2,
                   extractfilename(TempName));
    xpos:=xpos+icondim;
    if xpos>=bit.width then
    begin
      xpos:=0;
      ypos:=ypos+icondim;
    end;
    icona.free;
  end;
  image1.picture.bitmap:=bit;
  bit.free;
  ProgressBar1.Position:=0;
  HelpBtn.Caption:='?';
  screen.cursor:=crdefault;
  Thumbsactive:=true;
end;





procedure TTPreForm.DirectoryListBox1Change(Sender: TObject);
begin
  RefreshAll;
end;
procedure TTPreForm.RefreshAll;
var
  dim:integer;
  DbName:String;
  bit:tbitmap;
begin
  DbName :=ExtractFileName(filelistbox1.directory+ '.db');
  updown2.position:=1;
  if fileexists(ThumbPath+'\'+DbName) then
  begin
    with table1 do
    begin
      active:=false;
      databasename :=ThumbPath;
      tablename :=ThumbPath+'\'+DbName;
      tabletype := ttparadox ;
      active:=true;
      Thumbsactive:=true;
    end;
    updatethumbsdb;
    leggidim(dim);
    refreshicons;
  end else
  Begin
    Thumbsactive:=false;
    bit:=tbitmap.create;
    bit.PixelFormat:=pf24bit;
    bit.Width:=scrollbox1.width;
    bit.Height:=scrollbox1.height;
    bit.Canvas.Brush.Color:=clWhite;
    bit.Canvas.FillRect(Rect(0,0,bit.Width,bit.Height));
    image1.picture.bitmap:=bit;
    bit.free;
  End;
end;

procedure TTPreForm.UpDown2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var DbName:String;
begin
  DbName :=ExtractFileName(filelistbox1.directory+ '.db');
  if fileexists(ThumbPath+'\'+DbName) then
  refreshicons else
  begin
    Thumbsactive:=False;
{    If FileListBox1.Items.Count> 0 then
     deletethumbsdb;
     createthumbsdb;}
  end;
end;

(*
procedure TTPreForm.UpDown1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if fileexists(directorylistbox1.directory+'\thumbs.db') then
begin
if messagedlg('Do you simply want to stretch existing thumbs to new size?(this will not recreate the dbase for thumbs) ',mtinformation,[mbok,mbno],0) =mrok then
refreshicons
else
begin
deletethumbsdb;
createthumbsdb;
end;
end
else
messagedlg('No thumbnails were created for this folder',mtinformation,[mbok],0);
end;
*)

procedure TTPreForm.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
larg,alt:integer;
current:integer;
npag:integer;
nrow,ncol:integer;
{mem:string;}
icondim:integer;
begin
  If Thumbsactive then
  begin
    npag:=updown2.position;
    icondim:=ThumbSize;{updown1.position;}
    larg:=image1.picture.bitmap.width;
    alt:=image1.picture.bitmap.height;

    ncol:=larg div icondim ;
    nrow:=alt div icondim;
    {current:=(npag-1)*(ncol*nrow)
        + (y div (icondim*ncol))
        + (x div icondim) +1;}
    current:=(npag-1)*(ncol*nrow)
        + y div icondim*ncol
        + x div icondim +1;
    table1.RecNo:=current;
    {image2.picture.bitmap.loadfromfile}
    ImagePath := filelistbox1.directory+'\';
  If ( {( ssLeft in Shift) and }(ssShift in Shift)) then
    begin
       TongFilename :=table1.fields[0].asstring;
       LoadOneImage;
       TongsForm.SetFormCaption;
    end else
    TongsForm.LoadFromFile(table1.fields[0].asstring);
    {(filelistbox1.directory+'\'+table1.fields[0].asstring);}
  end;
end;
procedure TTPreForm.LoadOneImage;
var
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  Target:TBitmap;
begin
  GraphicClass := FileFormatList.GraphicFromContent(ImagePath +TongFilename);
  if GraphicClass = nil then Image2.Picture.LoadFromFile(ImagePath +TongFilename)
  else
  begin
    // GraphicFromContent always returns TGraphicExGraphicClass
    Graphic := GraphicClass.Create;
    Graphic.LoadFromFile(ImagePath +TongFilename);
    Image2.Picture.Graphic := Graphic;
  end;
  if (not(Image2.Picture.Graphic is TBitmap)) then
  begin
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
    Target.Width := Image2.Picture.Width;
    Target.Height := Image2.Picture.Height;
    Target.Canvas.Draw(0, 0, Image2.Picture.Graphic);
    Image2.Picture.Graphic := Target;
    Target.Free;
  end;
  Image2.Picture.Bitmap.PixelFormat := pf24bit;
  TongsForm.Image1.Picture.Bitmap:=
      Image2.Picture.Bitmap;
end;


procedure TTPreForm.Button2Click(Sender: TObject);
begin
  deletethumbsdb;
end;
procedure TTPreForm.deletethumbsdb;
var DbName:String;
begin
  {DbName :=ThumbPath+'\'+filelistbox1.directory;}
                 {thumbs}
  DbName :=ExtractFileName(filelistbox1.directory+ '.db');
  DbName :=ThumbPath+'\'+DbName;
  if fileexists(DbName) then
  begin
    image1.picture.Assign(nil);
    table1.active:=false;
    deletefile(DbName);
    deletefile(ChangeFileExt(DbName, '.px'));
    deletefile(ChangeFileExt(DbName, '.mb'));
    deletefile(ChangeFileExt(DbName, '.val'));
  end;
end;


(*
procedure TTPreForm.CreateThumbnail(const InFileName, OutFileName: string;
  Width, Height: Integer; FillColor: TColor=clWhite);
var
  JpegImage: TJpegImage;
  Bitmap: TBitmap;
  Ratio: Double;
  ARect: TRect;
  AHeight, AHeightOffset: Integer;
  AWidth, AWidthOffset: Integer;
begin
//  Check for invalid parameters
  if Width<1 then
    raise Exception.Create('Invalid Width');
  if Height<1 then
    raise Exception.Create('Invalid Height');
  JpegImage:=TJpegImage.Create;
  try
//  Load the image
    JpegImage.LoadFromStream(InStream);
// Create bitmap, and calculate parameters
    Bitmap:=TBitmap.Create;
    try
      Ratio:=JpegImage.Width/JpegImage.Height;
      if Ratio>1 then
      begin
        AHeight:=Round(Width/Ratio);
        AHeightOffset:=(Height-AHeight) div 2;
        AWidth:=Width;
        AWidthOffset:=0;
      end
      else
      begin
        AWidth:=Round(Height*Ratio);
        AWidthOffset:=(Width-AWidth) div 2;
        AHeight:=Height;
        AHeightOffset:=0;
      end;
      Bitmap.Width:=Width;
      Bitmap.Height:=Height;
      Bitmap.Canvas.Brush.Color:=FillColor;
      Bitmap.Canvas.FillRect(Rect(0,0,Width,Height));
// StretchDraw original image
      ARect:=Rect(AWidthOffset,AHeightOffset,
                  AWidth+AWidthOffset,
                  AHeight+AHeightOffset);
      Bitmap.Canvas.StretchDraw(ARect,JpegImage);
// Assign back to the Jpeg, and save to the file
      JpegImage.Assign(Bitmap);
      JpegImage.SaveToStream(OutStream);
    finally
      Bitmap.Free;
    end;
  finally
    JpegImage.Free;
  end;
end;
*)

(*
Function TTPreForm.FetchaThumb(InFileName: string):TBitmap;
var
  FetchaBitmap: TBitmap;
  DbName:String;
  test:Boolean;
Begin
  DbName :=ExtractFileName(ExtractFilePath(InFileName)+ '.db');
with table1 do
begin
  {Db exists so start it}
  active := false ;
  databasename :=ThumbPath;
  tablename :=ThumbPath+'\'+DbName; {thumbs}
  tabletype := ttparadox ;
  if (not fileexists(ThumbPath+'\'+DbName)) then
       createtable;
  active:=true;
  cancel;
  FetchaBitmap:=TBitmap.Create;
  test:=findkey([ExtractFileName(InFileName)]);
  If (not test) then AddOneImage(InFileName);
  FetchaBitmap.Assign(table1.fieldbyname('Image')) ;
  FetchaThumb:=FetchaBitmap;
  end;
End;         *)

procedure TTPreForm.AddOneImage(MyFileName: string);
var
  dim,larg,alt:integer;
  blob,mybit:tbitmap;
  myhandle:thandle;
  Date,Time:string;
  GraphicClass: TGraphicExGraphicClass;
  Graphic: TGraphic;
  Target:TBitmap;
begin
  dim:=Thumbsize;
  mybit:=tbitmap.create;
  {MyFileName:=ResultFileList.Strings[i]; }
  GraphicClass := FileFormatList.GraphicFromContent(MyFileName);
  if GraphicClass = nil then Image1.Picture.LoadFromFile(MyFileName)
  else
  begin
    // GraphicFromContent always returns TGraphicExGraphicClass
    Graphic := GraphicClass.Create;
    Graphic.LoadFromFile(MyFileName);
    Image1.Picture.Graphic := Graphic;
  end;
  if (not(Image1.Picture.Graphic is TBitmap)) then
  begin
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
    Target.Width := Image1.Picture.Width;
    Target.Height := Image1.Picture.Height;
    Target.Canvas.Draw(0, 0, Image1.Picture.Graphic);
    Image1.Picture.Graphic := Target;
    Target.Free;
  end;
  Image1.Picture.Bitmap.PixelFormat := pf24bit;
  {mybit:=Image1.Picture.Bitmap;}
  mybit.assign(Image1.Picture.Bitmap);
  mybit.PixelFormat:=pf24bit;
  larg:=mybit.width;
  alt:=mybit.height;
  if larg=0 then  larg:=10;
  if alt=0 then alt:=10;
  blob:=tbitmap.create;
  blob.PixelFormat:=pf24bit;
    Target := TBitmap.Create;
    Target.PixelFormat := pf24Bit;
  if larg>alt then
  begin
    blob.Width:=dim;
    blob.height:=round(alt/larg*dim);
  end
  else
  begin
    blob.height:=dim;
    blob.width:=round(larg/alt*dim);
  end;
{  blob.canvas.stretchdraw(rect(0,0,blob.width-1,blob.height-1),mybit);}
      Target.height:=blob.height;
      Target.width:=blob.width;
      Stretch(Target.width, Target.height,
      TResamplingFilter(GraphexFilter), 0,
                        mybit,Target);
    blob.canvas.Draw(0,0,Target);
  mybit.free;
  Target.free;
  myhandle:=fileopen(MyFileName,fmopenread);
  Date:=datetostr(filedatetodatetime(filegetdate(myhandle)));
  Time:=timetostr(filedatetodatetime(filegetdate(myhandle)));
  table1.InsertRecord([extractfilename(MyFileName),
               uppercase(extractfileext(MyFileName)),
               Date,Time,blob]);
  fileclose(myhandle);
  blob.free;
end;


  (*
procedure TTPreForm.CreateThumbsAlbum;
var
  i:Integer;
  DbName:string;
begin
  screen.cursor:=crhourglass;
  with table1 do
  begin
    if ResultFileList.Count>0 then
    begin
      ResultFileList.Sorted:=True;
      active := false ;
      databasename :=ThumbPath;
      DbName :=ExtractFileName(ExtractFilePath(ResultFileList[0])+ '.db');
      tablename :=ThumbPath+'\'+DbName;
      tabletype := ttparadox ;
      createtable;
      active:=true;
      cancel;
      for i:=0 to ResultFileList.Count-1 do
      begin
        AddOneImage(ResultFileList.Strings[i]);
      end;
    end;
  end;
  screen.cursor:=crdefault;
end;
*)


end.
