unit TongGlobals;

interface

uses
  Windows,
  Classes,{TStringList}
  FileCtrl, Sysutils{Filestuff},
  Dialogs{MessageDlg},
  Shellapi,{ShellExecute}
  Forms,{App}
  Graphics{Graphics};

const
  SELDIRHELP = 120;{SelectDirectory help}

type
  PHugeTByteArray = ^THugeTByteArray;
  THugeTByteArray = array[0..0, 0..0, 0..0] of Byte;
  PHugeByteArray = ^THugeByteArray;
  THugeByteArray = array[0..0] of Byte;
var
  BytesPerLine, ImageHeight, ImageWidth, InfoSize, ImageSize,
    WherePixel,  hRedBitmap, hGreenBitmap, hBlueBitmap,
    Undoh, Workh, Imageh:  DWord;
  pRedBitmapInfo, pGreenBitmapInfo, pBlueBitmapInfo,
    pUndoInfo, pWorkInfo, pImageInfo: PBitmapInfo;
  RedBitmap, GreenBitmap, BlueBitmap{, Undo, Work, Image}: Pointer;
  pPixelB, pPixelG, pPixelR,
    lpPixelB, lpPixelG, lpPixelR, lpPixelTR: ^Byte;
  Sample, SampleW, BottomRow, TopRow, RightColumn, LeftColumn: Integer;
  dXTemp, dYTemp, dXMIN, dYMIN, dXMAX, dYMAX: Double;

var {pf24bit pf32bit}
  ImagePixelFormat, MyPixelFormat: TPixelFormat;
  ImagePixelScanSize, MyPixelScanSize: Byte;
  Colorreg: Integer;
  Started: TDateTime;
  StartedNameNumber: string;
{Mouse Cropping, Drawing, ...}
type
  TDrawingTool =
    (dtEllipse, dtCSEllipse, dtPolygon,
    dtVTriangle, dtTriangle, dtTSTriangle,
    dtVPRectangle, dtVERectangle, dtVSRectangle,
    dtVDRectangle, dtVTRectangle, dtVFRectangle, dtVNRectangle,
    dtVMRectangle, dtVARectangle, dtVWRectangle, dtVCRectangle,
    dtVBRectangle, dtVRectangle, dtRectangle, dtRoundRect,
    dtLine, dtMLine,dtPBrush);
var DrawingTool: TDrawingTool;

{Morphing }
type
  aLineRecord = record
  p1,p2:TPoint;
  end;
  LineRecord = record
  Start,Finish,Result:Array[0..1] of TPoint;
  DeltaXs,DeltaYs,DeltaXf,DeltaYf,DeltaXr,DeltaYr:Integer;
  Lengths,Lengthf,Lengthr:Double;
  LengthSQs,LengthSQf,LengthSQr:Integer;
  end;
var
    MorphArray:Array of LineRecord;
    MorphArrayFile:File of LineRecord;
    MorphTweens,MorLineCount,GrabMDistance:Integer;


type
  ObjectMarker = record
    IsSolidFill: Boolean;
    ObjectType, X1, X2, Y1, Y2: Integer;
    LineColor, FillColor: TColor;
  end;

  ObjectLabel = record
    LOText: string[250];
    RotAngle, X, Y: Integer;
    Rotated, TransBack: Boolean;
    BackColor: TColor;
    LOFont: TFont;
  end;
var
  ObjectMarkerArray: array of ObjectMarker;
  ObjectLabelArray: array of ObjectLabel;
  SelectionRadius,  CurrentObjectMarker, ObjectListCount: Integer;
  {CurrentLabel,  LabelListCount:Integer;}
  ObjectMarking, ObjectMarkingOn,
  ObjectLabeling, ObjectLabelingOn: Boolean;
  MarkerBitmap, LabelBitmap:TBitmap;
TYPE
  ClassifiedRecord = record {ClassifiedArray: Array of }
    Rcent, Rmin, Rmax,
    Gcent, Gmin, Gmax,
    Bcent, Bmin, Bmax: Byte;
    Count, RValues, GValues, BValues: Integer;
    Radius, SDeviation, Variance: Double;
  end;
var   ClassifiedArray: array of ClassifiedRecord;

type
  StatsRecord = record
  SD, Variance:Double;
  Min,Max,Mean,Median,Mode,Sum,Num,Range:integer;
  CoVariance: Array of Double;
  JacobiEigenvalues:Double;
  end;
var StatsArray: array of StatsRecord;

type
  PrefRecord = record
  POldFileName4,
  POldFileName3,
  POldFileName2,
  POldFileName1,
  POldFileName0,
  {This is my secret string ? as text?}
  PHiddenString: string[255]; {array [1..256] of Char;}
  PColor256Name, {PTempName,} PProLoaded,
  PInfoString, PConfirmationString, PWarnString,
  PErrorString, PDoneString,
  PProgramPath,
  PILHProgram, PVRGISPath,
  PDTMPath,    PThumbPath,
  PFractal3DPath, PLifePath,  PSOSMAPPath,
  PDigitizerPath, PVoicePath,
  PProjectPath, PProjectName,
  PMapName, PMapsPath, PTreePath,
  PActorPath,PPanPath,PHTFPath,PDxfPath, ZipPath,
  PDbPath,PDemPath, PImagePath, PShapePath,
  PNoNamePath: string[255];
    PszMainBarColor,
    PMapContoursColor, PMapGridsColor,
    PMapDatasColor, PMapBacksColor,
    PThumbColor: TColor;
    PThumbSize: Integer;
    PGraphexFilter,
    PColorreg: Integer;
    PStarted: TDateTime;
    PStartedNameNumber: string[25];
    PScaleBarVisible,
    PPrintBigChecked, PUseThumbnails,
    PSkipIntroScreen, PSkip32BitNotice,
    POpenWithPreview, PSaveWithPreview,
    PErrorBeepOn, PWarningBeepOn ,PInfoBeepOn,
    PConfirmBeepOn, PCompletedBeepOn, PVoicesON :Boolean;

    PThresholdBarPosition{500}, PIntervalBarPosition{100},
    PJoyCentroidX,  PJoyCentroidY,
 {jpg options}
 PjpgScale, PjpgPixelFormat, PjpgColorSpace,
 PjpgPerformance, PJpgQuality :Integer;
 PjpgComments:string[255];
 {PIntelJpgAvailable,}{Tested..Set on App create.. NOT SET by user}
 PjpgProgressiveDisplayOn,
 PjpgIncrementalDisplayOn :Boolean;

     PCropXWide,PCropYTall,{PGrabDistance,}
  {X Y Location of forms}
      PTongsFormX, PTongsFormY,      {Main}
      PMessageX, PMessageY,  {Message box}
      PAboutTongsX,PAboutTongsY,
      PTongt3de1FormX,PTongt3de1FormY,
      PTongt3dFormX,PTongt3dFormY,
      PTongImageRGBFormX, PTongImageRGBFormY,
      PTongImageDotRGBFormX, PTongImageDotRGBFormY,
      PTongPanImageFormX, PTongPanImageFormY,
      PTongsJoyFormX,PTongsJoyFormY,
      PZipFormX,PZipFormY,
  PTreeFormX,PTreeFormY,
  PszMainFormX,PszMainFormY,
  PTPreFormX,PTPreFormY,
  PszDupFormX,PszDupFormY,
  PSrchFormX,PSrchFormY,
  PDbPrintImagesFormX,PDbPrintImagesFormY,
  PDbSessionFormX,PDbSessionFormY,
  PefgPrintFormX,PefgPrintFormY,
  PDbPrintDataWOImageFrmX,PDbPrintDataWOImageFrmY,
  PDbPrintDataImageFrmX,PDbPrintDataImageFrmY,
  PPrePrintFormX,PPrePrintFormY,
  PPicAboutBoxX,PPicAboutBoxY,
  PPngInfoFormX,PPngInfoFormY,
  PJPEGFormX,PJPEGFormY,
  PJpgInfoFormX,PJpgInfoFormY, { ImageInfoFormX,ImageInfoFormY,}
  PGListFormX,PGListFormY,
  PGBFormX,PGBFormY,
  PFormConvertX,PFormConvertY,
  PDbNoteFormX,PDbNoteFormY,
  PDBAFormX,PDBAFormY,
  PDbAdrViewFormX,PDbAdrViewFormY,
  PDatabaseImporterFormX,PDatabaseImporterFormY,
   PDbBigAdrImgLblFrmX,PDbBigAdrImgLblFrmY,
   PDbAdrLblFormX,PDbAdrLblFormY,
   PDbAdrAllLblFormX,PDbAdrAllLblFormY,
    PDbAdrImgLblFrmX,PDbAdrImgLblFrmY,
    PGSizerFormX,PGSizerFormY,
  PImageCorrelateFormX,PImageCorrelateFormY,
  PPicViewBitmapX,PPicViewBitmapY,
  PImageSpecialsX,PImageSpecialsY,
  PDevILInfoX,PDevILInfoY,
  PDevILDialogFormX,PDevILDialogFormY,
  PDevILAboutX,PDevILAboutY,
  PGPaintFormX,PGPaintFormY,
      PDDevILFormX,PDDevILFormY,
      PNelsonMorpherFormX,PNelsonMorpherFormY,
      PNelsonCorrespondenceFormX,PNelsonCorrespondenceFormY,
      PNelsonOutputFormX,PNelsonOutputFormY,
      PAVIMorphFormX,PAVIMorphFormY,
      PAvifrm_prevX,PAvifrm_prevY,
      PAvifrm_mainX,PAvifrm_mainY,
      PITCFormX,PITCFormY,
      POverViewFormX,POverViewFormY,
      PResizeFormX,PResizeFormY,
      PRotateFormX ,PRotateFormY,
      PMagniFormX,PMagniFormY,
      PSatelliteImportFormX,PSatelliteImportFormY,
      PDTwainFormX,PDTwainFormY,
      PDTSendCommandFormX,PDTSendCommandFormY,
      PgraTTBX,PgraTTBY,
      PPrintersizeFormX,PPrintersizeFormY,
      PObjectMarkFormX,PObjectMarkFormY,
      PLabelObjectsFormX,PLabelObjectsFormY,
      PViewCursorScreenX,PViewCursorScreenY,
      PRegistrationFormX,PRegistrationFormY,
      PSystemInfoFormX,PSystemInfoFormY,
      PPropertyDialogX,PPropertyDialogY,
      PScaleFormX,PScaleFormY,
      POptionsFormX, POptionsFormY,
      PAffectsFormX, PAffectsFormY,
      PProgressMessageFormX,PProgressMessageFormY,
      PImageDatabaseFormX,PImageDatabaseFormY,
      PG32EveFormX,PG32EveFormY,
      PG32FormX,PG32FormY,
      PPanZoomRPaintFormX,PPanZoomRPaintFormY,
      PSecretDbFormX,PSecretDbFormY
      : Integer;
  end;
  PrefFile = file of PrefRecord;
var
  PreRcd: PrefRecord;
{File Names and Paths}
  OldFileName4,
  OldFileName3,
  OldFileName2,
  OldFileName1,
  OldFileName0,
  InfoString, ConfirmationString, WarnString,
  ErrorString, DoneString,
  HiddenString,
  TempMsgName,TempPassName,{Passing a file name}
  Tempt3dName,
  TongFilename,{FilePath, ImagePath}
  TransSearchDir, ThumbPath,
  ProgramPath,
  RasterPath,
  Fractal3DPath,  LifePath,  SOSMAPPath,
  DigitizerPath, VRGISPath, DTMPath,
  VoicePath, ILHProgram,
  ProjectName, ProjectPath, MapName,  MapsPath,
  HTFPath,ActorPath,PanPath, ShapePath, TreePath,
  DemPath,DxfPath,DbPath, ImagePath,
  NoNamePath, ZipPath,
  ViewFileName:String;

  {Form Locations}
  TongsFormX, TongsFormY,    {Main}
  MessageX, MessageY,  {Message box}
  AboutTongsX,AboutTongsY,
      TongPanImageFormX, TongPanImageFormY,
      TongsJoyFormX,TongsJoyFormY,
      TongImageRGBFormX,TongImageRGBFormY,
      Tongt3de1FormX,Tongt3de1FormY,
      Tongt3dFormX,Tongt3dFormY,
      TongImageDotRGBFormX,TongImageDotRGBFormY,
  GSizerFormX,GSizerFormY,
  ZipFormX,ZipFormY,
  TreeFormX,TreeFormY,
  szMainFormX,szMainFormY,
  TPreFormX,TPreFormY,
  szDupFormX,szDupFormY,
  SrchFormX,SrchFormY,
  DbPrintImagesFormX,DbPrintImagesFormY,
  DbSessionFormX,DbSessionFormY,
  efgPrintFormX,efgPrintFormY,
  DbPrintDataWOImageFrmX,DbPrintDataWOImageFrmY,
  DbPrintDataImageFrmX,DbPrintDataImageFrmY,
  PrePrintFormX,PrePrintFormY,
  PicAboutBoxX,PicAboutBoxY,
  JpgInfoFormX,JpgInfoFormY, { ImageInfoFormX,ImageInfoFormY,}
  GListFormX,GListFormY,
  GBFormX,GBFormY,
  FormConvertX,FormConvertY,
  DbNoteFormX,DbNoteFormY,
  DBAFormX,DBAFormY,
  DbAdrViewFormX,DbAdrViewFormY,
  DatabaseImporterFormX,DatabaseImporterFormY,
   DbBigAdrImgLblFrmX,DbBigAdrImgLblFrmY,
   DbAdrLblFormX,DbAdrLblFormY,
   DbAdrAllLblFormX,DbAdrAllLblFormY,
    DbAdrImgLblFrmX,DbAdrImgLblFrmY,

  ImageCorrelateFormX,ImageCorrelateFormY,
  DDevILFormX,DDevILFormY,
  NelsonMorpherFormX,NelsonMorpherFormY,
  NelsonCorrespondenceFormX,NelsonCorrespondenceFormY,
  NelsonOutputFormX,NelsonOutputFormY,
  AVIMorphFormX,AVIMorphFormY,
  Avifrm_prevX,Avifrm_prevY,
  Avifrm_mainX,Avifrm_mainY,
  ITCFormX,ITCFormY,
  GPaintFormX,GPaintFormY,
  PicViewBitmapX,PicViewBitmapY,
  ImageSpecialsX,ImageSpecialsY,
  DevILInfoX,DevILInfoY,
  DevILDialogFormX,DevILDialogFormY,
  DevILAboutX,DevILAboutY,
  OverViewFormX,OverViewFormY,
  ResizeFormX,ResizeFormY,
  RotateFormX ,RotateFormY,
  MagniFormX,MagniFormY,
  SatelliteImportFormX,SatelliteImportFormY,
  DTwainFormX,DTwainFormY,
  DTSendCommandFormX,DTSendCommandFormY,
  graTTBX,graTTBY,
  PrintersizeFormX,PrintersizeFormY,
  ObjectMarkFormX,ObjectMarkFormY,
  LabelObjectsFormX,LabelObjectsFormY,
  ViewCursorScreenX,ViewCursorScreenY,
  RegistrationFormX,RegistrationFormY,
  SystemInfoFormX,SystemInfoFormY,
  PropertyDialogX,PropertyDialogY,
  ScaleFormX,ScaleFormY,
  OptionsFormX, OptionsFormY,
  AffectsFormX, AffectsFormY,
  ProgressMessageFormX,ProgressMessageFormY,
  PngInfoFormX,PngInfoFormY,
        SecretDbFormX,SecretDbFormY,

  JPEGFormX,JPEGFormY,
  ImageDatabaseFormX,ImageDatabaseFormY,
  G32EveFormX,G32EveFormY,
  G32FormX,G32FormY,
  FormPrintX,FormPrintY,
  PanZoomRPaintFormX,PanZoomRPaintFormY
  : Integer;
type
  Array3DRecord = record
  RX,GY,BZ:Byte;
  Count:Integer;
  end;
var
  Array3D: array of Array3DRecord;
  Array3DCounter:Integer;
   GraphexFilter: Integer;
{Thumbnail parameters.. No Thumbnails Here ?}
    ThumbColor: TColor;
    ThumbSize: Integer;
  ThumbnailsUsed, Skip32BitNotice,PrintBigChecked,
  Drawing,{bZoomMousing,ImageDrawChecked,}ViewMagniOn,
  AlreadyGone, ScaleBarVisible,
{MorphingOn, MorphingOnDrawing,}
{Menu} NoGLRunning,
  OpenWithPreview, SaveWithPreview,
  SoundDllLocated,
  ToggleOn, ErrorVoiceOn, DoneBeepOn,  BellsOn, WhistlesOn: Boolean;
  ErrorBeepOn, WarningBeepOn ,InfoBeepOn, SkipIntroScreen,
  ConfirmBeepOn, CompletedBeepOn, VoicesON :Boolean;
  szMainBarColor,
{Bogus Map Markers...}
    MapContoursColor, MapGridsColor,
    MapDatasColor, MapBacksColor,
    CurrentColor,
    EditColor,HighlightColor,BackgroundColor,EditingColor:TColor;

    ThresholdBarPosition{500}, IntervalBarPosition{100},
    JoyCentroidX,  JoyCentroidY,
 {jpg options}
 jpgScale, {1:1, 1:2, 1:4, 1:8}
 jpgPixelFormat, {24 bit  8 bit}
 jpgColorSpace, {RGB Gray}
 jpgPerformance,  {Quality Speed}
 JpgQuality {1..100}    :Integer;
 jpgComments:String;
 IntelJpgAvailable,{Tested..Set on App create.. NOT SET by user}
 jpgProgressiveDisplayOn :Boolean;
 jpgIncrementalDisplayOn :Boolean;

TongsAlreadyGone:Boolean;
TongImageWidth,TongImageHeight:Integer;
var
{Affects Form FX Variables}
{    FAirBrush:TjvAirBrush;
    Fpolygonchecked: boolean;
  appldir:string;
  ImgDrawFactor:byte;
    rotangle:integer;
  paintercaption:string;
  myoldshape:string;
  Fshapes:TStringlist;
  drawmode:string;
  shadowdx:integer;
  shadowdy:integer;
  shadow:tcolor;
  pastemode:string;
  GadLabelX,GadLabelY:integer; }
  pointarray:array[0..12] of Tpoint;
  freepoly: array [0..100] of tpoint;
  TraceB:byte;
  freepolycount:integer;
  blocks: integer;
  NSpiro:integer;
  stars,starpoints: integer;
  spiralfactor:Double;
  spiraldir, spirals: integer;
  decoX,decoY:integer;
  onColorPicked,  RangeTransColor,
  wavepen,wavebrush:tcolor;
  mypen:tpenmode;
  zoomclip:tbitmap;
  zoomrect:trect;
  myclip:tbitmap;
  mycliprect:trect;
  myclipcm:Tcopymode;
  mybezier: array[0..3]of tpoint;
  myskew:array [0..4] of tpoint;
  mychord:array [1..8] of integer;
  myslinetol:integer;
  myround:integer;
  myslinedir,  myshape:string;
  mypenstyle:tpenstyle;
  myoldbrushstyle:tbrushstyle;
  myoldpenwidth:integer;
  mydraw,  polygonchecked,
  bezierfix1,bezierfix2:boolean;
  TargetPoint, myorigin,myprevpoint:Tpoint;

{MOUSING}
  CropXWide,CropYTall, {Mouse Crop Rect sizes}
  PixelLine:Integer;
  DrawingToolPBrushWidth, ITriangling: Integer;
  pointStart,pointEnd,DIYX3Y3,DIYX4Y4,Origin, MovePt:TPoint;
  OverViewActive,
  ViewCursorOn,ViewCursorOnReally: Boolean;
  ViewX1, ViewX2, ViewY1, ViewY2, ThingToDo: Word;
  MagnifierSize  : Integer;

{Form control Free when Finished}
    LabelObjectsFormActive, ObjectMarkFormActive: Boolean;
ResultFileList:TStringList;
  MySysHandle: THandle;
  MMSysHandle: THandle;
  PlaySound: function(lpszSoundName: PAnsiChar; uFlags: UINT): BOOL;
  stdcall;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
procedure  ResetDefaults;  
procedure DoLoader;
procedure SetPreferences;
procedure DoSaver;
procedure GetPreferences;
Function DoConfirm(Choice: Integer):Word;
procedure DoMessages(Choice: Integer);
Function DoColorEditDead(Input:String): Integer;

implementation

Function DoColorEditDead(Input:String): Integer;
(*var
  NameI1, NameI2, NameI3, NameI4, NameI5, NameI6, NameI7, NameI,
    Totaler, Totaler3{, ColorCode}: Integer;
  NameS: string;
  cChar: Char;*)
Begin
(*
  Result:=0;       //'Not Registered'
  if (StartedNameNumber =Input ) then
  begin
    Result:=-1;
  end else
  if (Length(StartedNameNumber) <> 20) then
  begin end//DoMessages(17)
  else
  begin
     Result:=1;
      NameS := StartedNameNumber;
      cChar := NameS[11];
      NameI1 := (ord(cChar) );
      cChar := NameS[12];
      NameI2 := (ord(cChar) );
      cChar := NameS[13];
      NameI3 := (ord(cChar));
      cChar := NameS[14];
      NameI4 := (ord(cChar));
      cChar := NameS[15];
      NameI5 := (ord(cChar) );
      cChar := NameS[16];
      NameI6 := (ord(cChar) );
      cChar := NameS[17];
      NameI7 := (ord(cChar) );
      Totaler := (NameI1) + (NameI4) + (NameI3)- (NameI7);
      NameI := (NameI5) + (NameI6) + (NameI2);

      cChar := NameS[18];
      NameI4 := (ord(cChar));
      cChar := NameS[19];
      NameI5 := (ord(cChar) );
      cChar := NameS[20];
      NameI6 := (ord(cChar) );
      Totaler3 := (((NameI4) + (NameI6)) - (NameI5));

      Totaler := Totaler + Totaler3;
      if (Totaler <> NameI) then
      begin end //DoMessages(16)
      else
      begin
        Result:=2;
      end;
  end;
*)
Result:=2;
End;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..255] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;
{nil="open"	=opens the file specified by lpFile. }
{FileName=Grafree.exe}
{Params=Signal and Text filename}
{DefaultDir=This apps location as the file is created there}
{ShowCmd=SW_SHOWNORMAL}



{Reset Directories and all other defaults}
procedure  ResetDefaults;
Begin
    ProgramPath := ExtractFilePath(ParamStr(0));
{    FilePath := ProgramPath ;}
  ProjectPath := ProgramPath;
  MapsPath :=ProgramPath;
  TreePath :=ProgramPath;
  DemPath := ProgramPath;
  HTFPath := ProgramPath;
  ImagePath := ProgramPath;
  ShapePath := ProgramPath;
  DbPath := ProgramPath;
  ZipPath :=ProgramPath;
  PanPath := ProgramPath;
  DXFPath := ProgramPath;
  ActorPath := ProgramPath;

  ILHProgram :=ProgramPath;
  LifePath :=ProgramPath;
  Fractal3DPath :=ProgramPath;
  DTMPath :=ProgramPath;
  DigitizerPath :=ProgramPath;
  VoicePath :=ProgramPath;
  RasterPath :=ProgramPath;
  SOSMAPPath :=ProgramPath;
  VRGISPath :=ProgramPath;
  NoNamePath :=ProgramPath;

OldFileName0:=' ';
OldFileName1:=' ';
OldFileName2:=' ';
OldFileName3:=' ';
OldFileName4:=' ';
TongFilename:=' ';
   InfoString:= ProgramPath+ 'fyinfo.wav'; {Info}
   ConfirmationString:= ProgramPath+ 'confirm.wav';{ Confirmation}
   WarnString:= ProgramPath+ 'warn.wav';{Warn}
   ErrorString:= ProgramPath+ 'error.wav';{Error}
   DoneString:= ProgramPath+ 'done.wav';{Done}

  VoicesON := False;
  DoneBeepOn := False;
  ErrorVoiceOn := False;
  ErrorBeepOn := False;
  WarningBeepOn := False;
  InfoBeepOn := False;
  ConfirmBeepOn := False;
  CompletedBeepOn := False;
    OpenWithPreview:=True;
    SaveWithPreview:=True;
    Skip32BitNotice := False;
    PrintBigChecked:=True;
    ScaleBarVisible := False;
    SelectionRadius:=8;
    szMainBarColor:=clFuchsia;
  CurrentColor := clBlack;
  EditingColor:=clFuchsia;
  BackgroundColor:=clWhite;
  HighlightColor:=clYellow;
  EditColor:=clRed;
    MapContoursColor:=clGreen;
    MapGridsColor:=clOlive;
    MapDatasColor:=clRed;
    MapBacksColor:=clSilver;

    JoyCentroidX:=0;
    JoyCentroidY:=0;
    ThresholdBarPosition:=500;
    IntervalBarPosition:=100;
    ThumbColor:=clWhite;
    ThumbSize:=128;
    {showmessage(ProgramPath+'Thumbs'); }
  if DirectoryExists(ProgramPath+'Thumbs') then
     ThumbPath:=ProgramPath+'Thumbs'
  else
    if not CreateDir(ProgramPath+'Thumbs') then
      ThumbPath:=ProgramPath else
      ThumbPath:=ProgramPath+'Thumbs';
 GraphexFilter:=5;
 jpgScale :=0;
 jpgPixelFormat:=0;
 jpgColorSpace:=0;
 jpgPerformance:=0;
 JpgQuality:=60;
  jpgComments:='IJL15.DLL..DJ Taylor..ILH';
 {PIntelJpgAvailable,}{Tested..Set on App create.. NOT SET by user}
 jpgProgressiveDisplayOn:=False;
 jpgIncrementalDisplayOn:=False;
End;

procedure DoLoader;
var P_File: PrefFile;
var PathS: string;
begin {}
  PathS := ExtractFilePath(ParamStr(0)) + 'Tongs.pof';
  if FileExists(PathS) then
  begin
    AssignFile(P_File, PathS);
    Reset(P_File);
    if IoResult <> 0 then DoMessages(39984);
    Read(P_File, PreRcd);
    CloseFile(P_File);
    SetPreferences;
  end else DoMessages(39985);
end;


procedure SetPreferences;
begin {after loading}
  with PreRcd do begin
  OldFileName4:=POldFileName4;
  OldFileName3:=POldFileName3;
  OldFileName2:=POldFileName2;
  OldFileName1:=POldFileName1;
  OldFileName0:=POldFileName0;
  HiddenString:=PHiddenString;
  ProgramPath:=PProgramPath;
  DigitizerPath:=PDigitizerPath;
  Fractal3DPath:=PFractal3DPath;
  LifePath:=PLifePath;
  SOSMAPPath:=PSOSMAPPath;
  NoNamePath:=PNoNamePath;
  VRGISPath:=PVRGISPath;
  DTMPath:=PDTMPath;
  VoicePath:=PVoicePath;
  ILHProgram:=PILHProgram;
  ProjectPath:=PProjectPath;
  ProjectName:=PProjectName;
  MapName:=PMapName;
  MapsPath:=PMapsPath;
  HTFPath:=PHTFPath;
  PanPath:=PPanPath;
  ActorPath:=PActorPath;
  ShapePath:=PShapePath;
  DemPath:=PDemPath;
  DxfPath:=PDxfPath;
  DbPath:=PDbPath;
  ImagePath:=PImagePath;

  InfoString:=PInfoString;
  ConfirmationString:=PConfirmationString;
  WarnString:=PWarnString;
  ErrorString:=PErrorString;
  DoneString:=PDoneString;

  OpenWithPreview:=POpenWithPreview;
  SaveWithPreview:=PSaveWithPreview;
  ErrorBeepOn:=PErrorBeepOn;
  WarningBeepOn :=PWarningBeepOn;
  InfoBeepOn :=PInfoBeepOn;
  ConfirmBeepOn:=PConfirmBeepOn;
  CompletedBeepOn:=PCompletedBeepOn;
  SkipIntroScreen:=PSkipIntroScreen;
  ScaleBarVisible:=PScaleBarVisible;
  Skip32BitNotice:=PSkip32BitNotice;
  VoicesON :=PVoicesON;
    Started := PStarted;
    PrintBigChecked:=PPrintBigChecked;
    StartedNameNumber := PStartedNameNumber;
    Colorreg := PColorreg;
    GraphexFilter:=PGraphexFilter;
    ThumbnailsUsed:=PUseThumbnails;
    ThumbColor:=PThumbColor;
    ThumbSize:=PThumbSize;
    ThumbPath:=PThumbPath;
    szMainBarColor:=PszMainBarColor;
    ThresholdBarPosition{500}:=PThresholdBarPosition;
    IntervalBarPosition{100}:=PIntervalBarPosition;
        JoyCentroidX:=PJoyCentroidX;
        JoyCentroidY:=PJoyCentroidY;
(*
 PjpgScale, PjpgPixelFormat, PjpgColorSpace,
 PjpgPerformance, PJpgQualityTrackBar :Integer;
 PjpgComments:String;
 PIntelJpgAvailable,{Tested..Set on App create.. NOT SET by user}
 PjpgProgressiveDisplayOn,
 PjpgIncrementalDisplayOn :Boolean;*)

{GrabMDistance:=PGrabDistance;}
  CropXWide:=PCropXWide;
  CropYTall:=PCropYTall;
  TongsFormX:=PTongsFormX;
  TongsFormY:=PTongsFormY;
      MessageX:=PMessageX;
      MessageY:=PMessageY;
      AboutTongsX:=PAboutTongsX;
      AboutTongsY:=PAboutTongsY;
      Tongt3de1FormX:=PTongt3de1FormX;
      Tongt3de1FormY:=PTongt3de1FormY;
      Tongt3dFormX:=PTongt3dFormX;
      Tongt3dFormY:=PTongt3dFormY;
      TongPanImageFormX:=  PTongPanImageFormX;
      TongPanImageFormY:= PTongPanImageFormY;
      TongImageDotRGBFormX:=PTongImageDotRGBFormX;
      TongImageDotRGBFormY:=PTongImageDotRGBFormY;
      TongImageRGBFormX:=PTongImageRGBFormX;
      TongImageRGBFormY:=PTongImageRGBFormY;
      TongsJoyFormX:=PTongsJoyFormX;
      TongsJoyFormY:=PTongsJoyFormY;
  GSizerFormX:=PGSizerFormX;
  GSizerFormY:=PGSizerFormY;
      ZipFormX:=PZipFormX;
      ZipFormY:=PZipFormY;
  TreeFormX:=PTreeFormX;
  TreeFormY:=PTreeFormY;
  szMainFormX:=PszMainFormX;
  szMainFormY:=PszMainFormY;
  TPreFormX:=PTPreFormX;
  TPreFormY:=PTPreFormY;
  szDupFormX:=PszDupFormX;
  szDupFormY:=PszDupFormY;
  SrchFormX:=PSrchFormX;
  SrchFormY:=PSrchFormY;
  DbPrintImagesFormX:=PDbPrintImagesFormX;
  DbPrintImagesFormY:=PDbPrintImagesFormY;
  DbSessionFormX:=PDbSessionFormX;
  DbSessionFormY:=PDbSessionFormY;
  efgPrintFormX:=PefgPrintFormX;
  efgPrintFormY:=PefgPrintFormY;
  DbPrintDataWOImageFrmX:=PDbPrintDataWOImageFrmX;
  DbPrintDataWOImageFrmY:=PDbPrintDataWOImageFrmY;
  DbPrintDataImageFrmX:=PDbPrintDataImageFrmX;
  DbPrintDataImageFrmY:=PDbPrintDataImageFrmY;
  PrePrintFormX:=PPrePrintFormX;
  PrePrintFormY:=PPrePrintFormY;
  PicAboutBoxX:=PPicAboutBoxX;
  PicAboutBoxY:=PPicAboutBoxY;
  JpgInfoFormX:=PJpgInfoFormX;
  JpgInfoFormY:=PJpgInfoFormY;
  GListFormX:=PGListFormX;
  GListFormY:=PGListFormY;
  GBFormX:=PGBFormX;
  GBFormY:=PGBFormY;
  FormConvertX:=PFormConvertX;
  FormConvertY:=PFormConvertY;
  DbNoteFormX:=PDbNoteFormX;
  DbNoteFormY:=PDbNoteFormY;
  DBAFormX:=PDBAFormX;
  DBAFormY:=PDBAFormY;
  DbAdrViewFormX:=PDbAdrViewFormX;
  DbAdrViewFormY:=PDbAdrViewFormY;
  DatabaseImporterFormX:=PDatabaseImporterFormX;
  DatabaseImporterFormY:=PDatabaseImporterFormY;
   DbBigAdrImgLblFrmX:=PDbBigAdrImgLblFrmX;
   DbBigAdrImgLblFrmY:=PDbBigAdrImgLblFrmY;
   DbAdrLblFormX:=PDbAdrLblFormX;
   DbAdrLblFormY:=PDbAdrLblFormY;
   DbAdrAllLblFormX:=PDbAdrAllLblFormX;
   DbAdrAllLblFormY:=PDbAdrAllLblFormY;

    DbAdrImgLblFrmX:=PDbAdrImgLblFrmX;
    DbAdrImgLblFrmY:=PDbAdrImgLblFrmY;

      ImageCorrelateFormX:=PImageCorrelateFormX;
      ImageCorrelateFormY:=PImageCorrelateFormY;
      DDevILFormX:=PDDevILFormX;
      DDevILFormY:=PDDevILFormY;
      NelsonMorpherFormX:=PNelsonMorpherFormX;
      NelsonMorpherFormY:=PNelsonMorpherFormY;
      NelsonCorrespondenceFormX:=PNelsonCorrespondenceFormX;
      NelsonCorrespondenceFormY:=PNelsonCorrespondenceFormY;
      NelsonOutputFormX:=PNelsonOutputFormX;
      NelsonOutputFormY:=PNelsonOutputFormY;
      AVIMorphFormX:=PAVIMorphFormX;
      AVIMorphFormY:=PAVIMorphFormY;
      Avifrm_prevX:=PAvifrm_prevX;
      Avifrm_prevY:=PAvifrm_prevY;
      Avifrm_mainX:=PAvifrm_mainX;
      Avifrm_mainY:=PAvifrm_mainY;
      ITCFormX:=PITCFormX;
      ITCFormY:=PITCFormY;
      GPaintFormX:=PGPaintFormX;
      GPaintFormY:=PGPaintFormY;
      PicViewBitmapX:=PPicViewBitmapX;
      PicViewBitmapY:=PPicViewBitmapY;
  ImageSpecialsX:=PImageSpecialsX;
  ImageSpecialsY:=PImageSpecialsY;
  DevILInfoX:=PDevILInfoX;
  DevILInfoY:=PDevILInfoY;
  DevILDialogFormX:=PDevILDialogFormX;
  DevILDialogFormY:=PDevILDialogFormY;
  DevILAboutX:=PDevILAboutX;
  DevILAboutY:=PDevILAboutY;
  OverViewFormX:=POverViewFormX;
  OverViewFormY:=POverViewFormY;
  ResizeFormX:=PResizeFormX;
  ResizeFormY:=PResizeFormY;
      RotateFormX:=PRotateFormX;
      RotateFormY:=PRotateFormY;
      MagniFormX:=PMagniFormX;
      MagniFormY:=PMagniFormY;

  ObjectMarkFormX:=PObjectMarkFormX;
  ObjectMarkFormY:=PObjectMarkFormY;
  LabelObjectsFormX:=PLabelObjectsFormX;
  LabelObjectsFormY:=PLabelObjectsFormY;
      OptionsFormX:=POptionsFormX;
      OptionsFormY:=POptionsFormY;
      JPEGFormX:=PJPEGFormX;
      JPEGFormY:=PJPEGFormY;
      AffectsFormX:=PAffectsFormX;
      AffectsFormY:=PAffectsFormY;
      G32EveFormX:=PG32EveFormX;
      G32EveFormY:=PG32EveFormY;
      G32FormX:=PG32FormX;
      G32FormY:=PG32FormY;
      JpgInfoFormX:=PJpgInfoFormX;
      JpgInfoFormY:=PJpgInfoFormY;
  PanZoomRPaintFormX:=PPanZoomRPaintFormX;
  PanZoomRPaintFormY:=PPanZoomRPaintFormY;
  ImageDatabaseFormX:=PImageDatabaseFormX;
  ImageDatabaseFormY:=PImageDatabaseFormY;
        SecretDbFormX:=PSecretDbFormX;
        SecretDbFormY:=PSecretDbFormY;
  end;
end;
{---------------------------------------------------------------------}

procedure DoSaver;
var P_File: PrefFile;
var PathS: string;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'Tongs.pof';
  if (not FileExists(PathS)) then DoMessages(14{39987});
  GetPreferences;
  AssignFile(P_File, PathS);
  Rewrite(P_File);
  if IoResult <> 0 then
  begin
    DoMessages(39986);
  end;
  write(P_File, PreRcd);
  CloseFile(P_File);
end;
{---------------------------------------------------------------------}

procedure GetPreferences;
begin {before saving}
  with PreRcd do begin
  POldFileName4:=OldFileName4;
  POldFileName3:=OldFileName3;
  POldFileName2:=OldFileName2;
  POldFileName1:=OldFileName1;
  POldFileName0:=OldFileName0;
  PHiddenString:=HiddenString;
    PColorreg := Colorreg;
    PStarted := Started;
    PStartedNameNumber := StartedNameNumber;
  PPrintBigChecked:=PrintBigChecked;
  POpenWithPreview:=OpenWithPreview;
  PSaveWithPreview:=SaveWithPreview;

  PProgramPath:=ProgramPath;
  PFractal3DPath:=Fractal3DPath;
  PLifePath:=LifePath;
  PSOSMAPPath:=SOSMAPPath;
  PNoNamePath:=NoNamePath;
  PDigitizerPath:=DigitizerPath;
  PVRGISPath:=VRGISPath;
  PDTMPath:=DTMPath;
  PVoicePath:=VoicePath;
  PILHProgram:=ILHProgram;
  PProjectPath:=ProjectPath;
  PProjectName:=ProjectName;
  PMapName:=MapName;
  PMapsPath:=MapsPath;
  PHTFPath:=HTFPath;
  PActorPath:=ActorPath;
  PPanPath:=PanPath;
  PShapePath:=ShapePath;
  PDemPath:=DemPath;
  PDxfPath:=DxfPath;
  PDbPath:=DbPath;
  PImagePath:=ImagePath;

  PInfoString:=InfoString;
  PConfirmationString:=ConfirmationString;
  PWarnString:=WarnString;
  PErrorString:=ErrorString;
  PDoneString:=DoneString;

    PThresholdBarPosition{500}:=ThresholdBarPosition;
    PIntervalBarPosition{100}:=IntervalBarPosition;
        PJoyCentroidX:=JoyCentroidX;
        PJoyCentroidY:=JoyCentroidY;

  PScaleBarVisible:=ScaleBarVisible;
  PSkipIntroScreen:=SkipIntroScreen;
  PErrorBeepOn:=ErrorBeepOn;
  PWarningBeepOn :=WarningBeepOn;
  PInfoBeepOn :=InfoBeepOn;
  PConfirmBeepOn:=ConfirmBeepOn;
  PCompletedBeepOn:=CompletedBeepOn;
  PSkip32BitNotice:=Skip32BitNotice;
  PGraphexFilter:=GraphexFilter;
  PUseThumbnails:=ThumbnailsUsed;
    PThumbColor:=ThumbColor;
     PThumbSize:=ThumbSize;
    PThumbPath:=ThumbPath;
    PszMainBarColor:=szMainBarColor;
  PVoicesON :=VoicesON;
  PCropXWide:=CropXWide;
  PCropYTall:=CropYTall;
{  PGrabDistance:=GrabMDistance;}
  PTongsFormX:=TongsFormX;
  PTongsFormY:=TongsFormY;
      PMessageX:=MessageX;
      PMessageY:=MessageY;
      PAboutTongsX:=AboutTongsX;
      PAboutTongsY:=AboutTongsY;
      PTongt3de1FormX:=Tongt3de1FormX;
      PTongt3de1FormY:=Tongt3de1FormY;
      PTongt3dFormX:=Tongt3dFormX;
      PTongt3dFormY:=Tongt3dFormY;
      PTongPanImageFormX:= TongPanImageFormX;
      PTongPanImageFormY:= TongPanImageFormY;
      PTongImageRGBFormX:=TongImageRGBFormX;
      PTongImageRGBFormY:=TongImageRGBFormY;
      PTongImageDotRGBFormX:=TongImageDotRGBFormX;
      PTongImageDotRGBFormY:=TongImageDotRGBFormY;
      PTongsJoyFormX:=TongsJoyFormX;
      PTongsJoyFormY:=TongsJoyFormY;
  PGSizerFormX:=GSizerFormX;
  PGSizerFormY:=GSizerFormY;
      PZipFormX:=ZipFormX;
      PZipFormY:=ZipFormY;
  PTreeFormX:=TreeFormX;
  PTreeFormY:=TreeFormY;
  PszMainFormX:=szMainFormX;
  PszMainFormY:=szMainFormY;
  PTPreFormX:=TPreFormX;
  PTPreFormY:=TPreFormY;
  PszDupFormX:=szDupFormX;
  PszDupFormY:=szDupFormY;
  PSrchFormX:=SrchFormX;
  PSrchFormY:=SrchFormY;
  PDbPrintImagesFormX:=DbPrintImagesFormX;
  PDbPrintImagesFormY:=DbPrintImagesFormY;
  PDbSessionFormX:=DbSessionFormX;
  DbSessionFormY:=DbSessionFormY;
  PefgPrintFormX:=efgPrintFormX;
  PefgPrintFormY:=efgPrintFormY;
  PDbPrintDataWOImageFrmX:=DbPrintDataWOImageFrmX;
  PDbPrintDataWOImageFrmY:=DbPrintDataWOImageFrmY;
  PDbPrintDataImageFrmX:=DbPrintDataImageFrmX;
  PDbPrintDataImageFrmY:=DbPrintDataImageFrmY;
  PPrePrintFormX:=PrePrintFormX;
  PPrePrintFormY:=PrePrintFormY;
  PPicAboutBoxX:=PicAboutBoxX;
  PPicAboutBoxY:=PicAboutBoxY;
  PJpgInfoFormX:=JpgInfoFormX;
  PJpgInfoFormY:=JpgInfoFormY;
  PGListFormX:=GListFormX;
  PGListFormY:=GListFormY;
  PGBFormX:=GBFormX;
  PGBFormY:=GBFormY;
  PFormConvertX:=FormConvertX;
  PFormConvertY:=FormConvertY;
  PDbNoteFormX:=DbNoteFormX;
  PDbNoteFormY:=DbNoteFormY;
  PDBAFormX:=DBAFormX;
  PDBAFormY:=DBAFormY;
  PDbAdrViewFormX:=DbAdrViewFormX;
  PDbAdrViewFormY:=DbAdrViewFormY;
  PDatabaseImporterFormX:=DatabaseImporterFormX;
  PDatabaseImporterFormY:=DatabaseImporterFormY;
   PDbBigAdrImgLblFrmX:=DbBigAdrImgLblFrmX;
   PDbBigAdrImgLblFrmY:=DbBigAdrImgLblFrmY;
   PDbAdrLblFormX:=DbAdrLblFormX;
   PDbAdrLblFormY:=DbAdrLblFormY;
   PDbAdrAllLblFormX:=DbAdrAllLblFormX;
   PDbAdrAllLblFormY:=DbAdrAllLblFormY;
    PDbAdrImgLblFrmX:=DbAdrImgLblFrmX;
    PDbAdrImgLblFrmY:=DbAdrImgLblFrmY;

      PImageCorrelateFormX:=ImageCorrelateFormX;
      PImageCorrelateFormY:=ImageCorrelateFormY;
      PDDevILFormX:=DDevILFormX;
      PDDevILFormY:=DDevILFormY;
      PNelsonMorpherFormX:=NelsonMorpherFormX;
      PNelsonMorpherFormY:=NelsonMorpherFormY;
      PNelsonCorrespondenceFormX:=NelsonCorrespondenceFormX;
      PNelsonCorrespondenceFormY:=NelsonCorrespondenceFormY;
      PNelsonOutputFormX:=NelsonOutputFormX;
      PNelsonOutputFormY:=NelsonOutputFormY;
      PAVIMorphFormX:=AVIMorphFormX;
      PAVIMorphFormY:=AVIMorphFormY;
      PAvifrm_prevX:=Avifrm_prevX;
      PAvifrm_prevY:=Avifrm_prevY;
      PAvifrm_mainX:=Avifrm_mainX;
      PAvifrm_mainY:=Avifrm_mainY;
      PITCFormX:=ITCFormX;
      PITCFormY:=ITCFormY;
      PGPaintFormX:=GPaintFormX;
      PGPaintFormY:=GPaintFormY;
      PPicViewBitmapX:=PicViewBitmapX;
      PPicViewBitmapY:=PicViewBitmapY;
  PImageSpecialsX:=ImageSpecialsX;
  PImageSpecialsY:=ImageSpecialsY;
  PDevILInfoX:=DevILInfoX;
  PDevILInfoY:=DevILInfoY;
  PDevILDialogFormX:=DevILDialogFormX;
  PDevILDialogFormY:=DevILDialogFormY;
  PDevILAboutX:=DevILAboutX;
  PDevILAboutY:=DevILAboutY;
  PObjectMarkFormX:=ObjectMarkFormX;
  PObjectMarkFormY:=ObjectMarkFormY;
  PLabelObjectsFormX:=LabelObjectsFormX;
  PLabelObjectsFormY:=LabelObjectsFormY;
  POverViewFormX:=OverViewFormX;
  POverViewFormY:=OverViewFormY;
  PResizeFormX:=ResizeFormX;
  PResizeFormY:=ResizeFormY;
      PRotateFormX:=RotateFormX;
      PRotateFormY:=RotateFormY;
      PMagniFormX:=MagniFormX;
      PMagniFormY:=MagniFormY;
      PJpgInfoFormX:=JpgInfoFormX;
      PJpgInfoFormY:=JpgInfoFormY;
      PJPEGFormX:=JPEGFormX;
      PJPEGFormY:=JPEGFormY;
      PAffectsFormX:=AffectsFormX;
      PAffectsFormY:=AffectsFormY;
      PG32EveFormX:=G32EveFormX;
      PG32EveFormY:=G32EveFormY;
      PG32FormX:=G32FormX;
      PG32FormY:=G32FormY;
  PPanZoomRPaintFormX:=PanZoomRPaintFormX;
  PPanZoomRPaintFormY:=PanZoomRPaintFormY;
  PImageDatabaseFormX:=ImageDatabaseFormX;
  PImageDatabaseFormY:=ImageDatabaseFormY;
        PSecretDbFormX:=SecretDbFormX;
        PSecretDbFormY:=SecretDbFormY;
  end;
end;

{---------------------------------------------------------------}
Function DoConfirm(Choice: Integer):Word;
var
  Messagestr: string;
  HelpContextl: Longint;
{  s:array[0..79] of Char;}
begin
  HelpContextl := 110;
  case Choice of
    10001: Messagestr := 'Reduce Image to fit page?';
    10002: Messagestr := 'Database Exists: Append? '
                 +#13#10+'(Yes), Replace (No), Abort (Cancel)';
    end;
  case Choice of
    10000..19999:
    Result:=MessageDlgPos(Messagestr,
        mtConfirmation,
       {[mbOK],} mbYesNoCancel,
        HelpContextl,
        MessageX,
        MessageY);
    else Result:=0;{mrNone;}
    end;
end;

procedure DoMessages(Choice: Integer);
var
  Messagestr: string;
  HelpContextl: Longint;
  s:array[0..79] of Char;
begin
  case Choice of
  1..9999 : {mtInformation} HelpContextl := 115;
  10000..19999: {mtConfirmation}HelpContextl := 116;
  20000..29999:{ mtWarning}HelpContextl := 117;
  else{30000..40000:}{ mtError}HelpContextl := 118;
  end;

  case Choice of {DoMessages(11}
{1..9999 mtInformation	A message box containing a blue "i".}
    1: Messagestr := 'Not a Project file';
    2: Messagestr := 'Unknown file type';
    3: Messagestr := 'Not an X file';
    4: Messagestr := 'Not a Texture (bmp) file';
    5: Messagestr := 'Error loading X file'
      {+#13#10+XPath+CurrentXFile};
    6: Messagestr := 'Error loading BMP texture' {+
                #13#10+CurrentTexturePath+CurrentTextureFile};
    7: Messagestr := 'Error loading Project file' {+
                #13#10+ProjectPath+ProjectName};
    8: Messagestr := 'Not a Shape (*.shp) file';
    9: Messagestr := 'Not a Background (*.bmp) file';
    10: Messagestr := 'Not a DEM (*.bin) file';
    11: Messagestr := 'Not a dxf (*.dxf) file';
    12: Messagestr := 'Not a Database (*.db or *.dbf) file';
    13: Messagestr := 'Not an Image (*.bmp) file';
    14{39987}: Messagestr := 'Creating Tongs.pof File'
                     +#13#10+'Please Set Thumbnail directory in Program Options';
    15: Messagestr := 'Both Images MUST be the same size';
    16: Messagestr := 'Registration  Invalid';{(Totaler <> NameI)}
    17: Messagestr := 'No, be sure All characters are entered';
    40: Messagestr := 'Converts images: 32 to 24 bit Color';
    9998: Messagestr := 'Test Sound';
    9999: Messagestr := 'Resistance is futile'
             + #13#10 + 'All Messages end here';
{10000..19999 mtConfirmation	A message box containing a green question mark.}
    10000: Messagestr := 'Do you wanna dance?';
    10001: Messagestr := 'Reduce Image to fit page?';
    19999: Messagestr := 'Test Sound';
{20000..29999 mtWarning   A message box containing a yellow exclamation point symbol.}
    20000: Messagestr := 'Danger Danger';
    20001: Messagestr := 'Order.txt Files not found';
    20002: Messagestr := 'License.txt Files not found';
    20003: Messagestr := 'Readme.txt Files not found';
    20004: Messagestr := 'Tongs will fail without Registration'
                         +#13#10+'Registration Warning'
                         + #13#10 +'See Tongs About';
    20005: Messagestr := 'Danger Danger Rill Wobinson'
                +#13#10+ 'Resources < 10%, Browse aborted';
    20006: Messagestr :='Tongs will fail without Registration'
                         + #13#10 +'Registration Error'
                         + #13#10 +'See Tongs About';
    20007: Messagestr := 'Autosave bmp or png only';
    20008: Messagestr := 'not saved';

    22222: Messagestr := 'WINMM.DLL or MMSYSTEM.DLL required for Sound';
    29999: Messagestr := 'Test Sound';
{DoMessages( 20007}
{30000..40000 mtError  A message box containing a red stop sign.}
    30000: Messagestr := 'There is an Error in the system';
    30001: Messagestr := 'Tongs failed without Registration';
    30002: Messagestr := 'PicAlbum Bitmap File not found';
    30003: Messagestr := 'both radi must be >5';
    30004: Messagestr := 'sum of radi too large';
    30005: Messagestr := 'image must be square for spirographs';
    30006: Messagestr := 'grafxgb.txt File not found';
    30007: Messagestr := 'Requires 24 or 32 bit capability';
{DoMessages(30007); }
    39976: Messagestr := ' An error was detected when'
              + #13#10 + 'trying to fetch registration info.'
              + #13#10 + 'Could not locate registered user name';

    39983: Messagestr := 'Filename has reached 999';
    39984: Messagestr := 'Failed reading Tongs.pof File';
    39985: Messagestr := 'Tongs.pof Does NOT Exist';
    39986: Messagestr := 'Failed writing Tongs.pof File';
    39987: Messagestr := 'Creating Tongs.pof File';
    39988: Messagestr := 'Unable to delete the file: '+
                    #13#10 + TempMsgName +
                    #13#10+'Perhaps this file is still in use, ' +
                    #13#10+'or is write-protected ?';
    39989: Messagestr := 'Error changing '+TempMsgName ;
    39990: Messagestr := 'Cannot locate WINMM.DLL or MMSYSTEM.DLL.. no sounds';

    39996: Messagestr := 'Test Sound';
    39997: Messagestr := 'Error opening file '+TempMsgName ;
    39998: Messagestr := 'Error opening file';
    39999: Messagestr := 'There is an Error in the system';
    40000: Messagestr := 'FATAL Error creating bitmap... byebye';
    40001: Messagestr := 'Test Sound';
    else Messagestr := 'Unknown';
  end;

  case Choice of {2,147,483,648..2,147,483,647}
{mtInformation	A message box containing a blue "i".}
    1..9999:
    begin
        if ((WarningBeepOn) and (not VoicesON)) then Beep;
        if ((WarningBeepOn) and (VoicesON)) then
        begin
          if (FileExists(ExtractFilePath(ParamStr(0)) + 'fyinfo.wav'))then
          begin
            StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'fyinfo.wav');
            if (MMSysHandle <> 0) then  PlaySound(s,  0);
          end else beep;
        end;
    MessageDlgPos(Messagestr,
        mtInformation,
        [mbOK], {mbYesNoCancel,}
        HelpContextl,
        MessageX,
        MessageY);
        end;
{mtConfirmation	A message box containing a green question mark.}
    10000..19999:
    begin
        if ((WarningBeepOn) and (not VoicesON)) then Beep;
        if ((WarningBeepOn) and (VoicesON)) then
        begin
          if (FileExists(ExtractFilePath(ParamStr(0)) + 'confirm.wav'))then
          begin
            StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'confirm.wav');
            if (MMSysHandle <> 0) then  PlaySound(s,  0);
          end else beep;
        end;
    MessageDlgPos(Messagestr,
        mtConfirmation,
                {[mbOK],} mbYesNoCancel,
        HelpContextl,
        MessageX,
        MessageY);
        end;
{mtWarning   A message box containing a yellow exclamation point symbol.}
    20000..29999:
    begin
        if ((WarningBeepOn) and (not VoicesON)) then Beep;
        if ((WarningBeepOn) and (VoicesON)) then
        begin
          if (FileExists(ExtractFilePath(ParamStr(0)) + 'warn.wav'))then
          begin
            StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'warn.wav');
            if (MMSysHandle <> 0) then  PlaySound(s,  0);
          end else beep;
        end;
    MessageDlgPos(Messagestr,
        mtWarning,
        [mbOK], {mbYesNoCancel,}
        HelpContextl,
        MessageX,
        MessageY);
        end;
{mtError  A message box containing a red stop sign.}
    30000..40000:
    begin
        if ((WarningBeepOn) and (not VoicesON)) then Beep;
        if ((WarningBeepOn) and (VoicesON)) then
        begin
          if (FileExists(ExtractFilePath(ParamStr(0)) + 'error.wav'))then
          begin
            StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'error.wav');
            if (MMSysHandle <> 0) then  PlaySound(s,  0);
          end else beep;
        end;

        MessageDlgPos(Messagestr,
          mtError,
          [mbOK], {mbYesNoCancel,}
          HelpContextl,
          MessageX,
          MessageY);
      end;
    40001:
    begin
        if ((WarningBeepOn) and (not VoicesON)) then Beep;
        if ((WarningBeepOn) and (VoicesON)) then
        begin
          if (FileExists(ExtractFilePath(ParamStr(0)) + 'done.wav'))then
          begin
            StrPCopy(s, ExtractFilePath(ParamStr(0)) + 'done.wav');
            if (MMSysHandle <> 0) then  PlaySound(s,  0);
          end else beep;
        end;
      end;{case}  
  end;
end;

{---------------------------------------------------------------------}

end.
