unit rRegFrm;

{Purpose: Gather corner registration coords and Smear: Rubberband the image}
{Open image and data  .rpl Registration Point List
 Display Data points on Image
 Select a NEW data point.. Add to list and display on image}
{Data list can be opened, cleared, 1 item deleted and saved}
{ Process Image (LAST Thing to do)
Do ALL points Except 1: See where IT fits to get error}

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  pngimage,  jpeg, CurveFit,
  Buttons, ExtCtrls, StdCtrls, ComCtrls;

type
  TRegistrationForm = class(TForm)
    Panel1: TPanel;
    HelpBtn: TSpeedButton;
    ExitButton: TSpeedButton;
    UndoBtn: TSpeedButton;
    DisplayListBtn: TSpeedButton;
    SaveListBtn: TSpeedButton;
    LoadListBtn: TSpeedButton;
    StatusBar11: TStatusBar;
    ClearAllBtn: TSpeedButton;
    OpenBtn: TSpeedButton;
    ProcessBtn: TSpeedButton;
    OpenDialog: TOpenDialog;
    Panel3: TPanel;
    PlaceItBtn: TSpeedButton;
    XEdit: TEdit;
    YEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    MouseXLabel: TLabel;
    MouseYLabel: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel4: TPanel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Splitter1: TSplitter;
    Panel2: TPanel;
    ListBox1: TListBox;
    UpDownNumTerms: TUpDown;
    EditNumTerms: TEdit;
    LabelNumTerms: TLabel;
    MemoResults: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
procedure LoadFromFile(RegFilename: string);
    procedure ProcessBtnClick(Sender: TObject);
    procedure DisplayListBtnClick(Sender: TObject);
procedure DisplayTheList;
    {Sets Mouse Boolean}
    procedure PlaceItBtnClick(Sender: TObject);

    procedure LoadListBtnClick(Sender: TObject);
procedure LoadaListFile(RegListname: string);
    {Clear the List .. Clear the Image .. call  DisplayTheList}
    procedure ClearAllBtnClick(Sender: TObject);
    {Delete selected item.. call DisplayTheList}
    procedure UndoBtnClick(Sender: TObject);

    procedure SaveListBtnClick(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpDownNumTermsClick(Sender: TObject; Button: TUDBtnType);
procedure calculate_fit (const nTerms: integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Private declarations }
    SelectingOn:Boolean;
    RegFilename,RegListname:String;
    BackBitmap:TBitmap;
  public
    { Public declarations }
  end;

var
  RegistrationForm: TRegistrationForm;

implementation
uses  TongGlobals;
{$R *.DFM}

procedure TRegistrationForm.FormCreate(Sender: TObject);
begin
  SelectingOn:=False;
  left := RegistrationFormX;
  top := RegistrationFormY;
  BackBitmap := TBitmap.Create;
end;

procedure TRegistrationForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  BackBitmap.Free;
  RegistrationFormX := RegistrationForm.left;
  RegistrationFormY := RegistrationForm.top;
end;

procedure TRegistrationForm.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(1800);
end;

procedure TRegistrationForm.ExitButtonClick(Sender: TObject);
begin
 Close;
end;

procedure TRegistrationForm.OpenBtnClick(Sender: TObject);
begin
{Open an image and its Registration File.. if any}
    OpenDialog.InitialDir := ImagePath;
    OpenDialog.Filter := 'All (*.bmp;*.png)|*.bmp;*.png;*.jpg';
    if OpenDialog.Execute then
    begin
      ImagePath := ExtractFilePath(OpenDialog.Filename);
      RegFilename := ExtractFileName(OpenDialog.Filename);
      LoadFromFile(RegFilename);
      RegListname := ChangeFileExt(RegFilename,'rpl');
      If FileExists(ImagePath+RegListname) then LoadaListFile(RegListname);
    end;
end;

{Load a file}
procedure TRegistrationForm.LoadFromFile(RegFilename: string);
var
  PNG:TPNGObject;
  jp: TJpegImage;
begin
  RegistrationForm.Cursor:=CRHOURGLASS;
  Application.ProcessMessages;
  {Load the image}
  if (lowercase(extractfileext(RegFilename)) = '.bmp') then begin
    Image1.Picture.LoadFromFile(ImagePath + RegFilename);
  end else
  if (lowercase(extractfileext(RegFilename)) = '.jpg') then
  begin
        jp := TJpegImage.Create;
        try
          with jp do
          begin
          jp.LoadFromFile(ImagePath + RegFilename);
          Image1.Picture.Bitmap.Assign(jp);
          end;
        finally
          jp.Free;
        end;
  end else
  if (lowercase(extractfileext(RegFilename)) = '.png') then
  begin
    PNG := TPNGObject.Create;
    {In case something goes wrong, free both PNG and Bitmap}
    try
      PNG.LoadFromFile(ImagePath + RegFilename);
      Image1.Picture.Bitmap.Assign(PNG); //Convert data into bitmap
      finally
      PNG.Free;
    end;
  end;

  if (Image1.Picture.Bitmap.PixelFormat <> pf24bit) then
  begin
    if (Image1.Picture.Bitmap.PixelFormat = pf4bit)
      then {DoMessages(41)};
    if (Image1.Picture.Bitmap.PixelFormat = pf8bit)
      then {DoMessages(42)};
    if (Image1.Picture.Bitmap.PixelFormat = pf15bit)
      then{ DoMessages(43)};
    if (Image1.Picture.Bitmap.PixelFormat = pf16bit)
      then {DoMessages(44)};
    Image1.Picture.Bitmap.PixelFormat := pf24bit;
  end;
  {ImagePixelFormat:=Image1.Picture.Bitmap.PixelFormat;
  Loading := FALSE;
  Image1.Canvas.Draw(0,0,Image1.Picture.Graphic);}
  BackBitmap.assign(Image1.Picture.Bitmap);
  RegistrationForm.Caption:='Registration: '+RegFilename
  +', Width: '+Inttostr(Image1.Width)+', Height: '+Inttostr(Image1.Height);
  RegistrationForm.Cursor := CRDEFAULT;
end;


procedure TRegistrationForm.PlaceItBtnClick(Sender: TObject);
begin
{Get Mouse X,Y and USER Data Input
ListBox1.Items.Add(Edit1.Text);  }
  PlaceItBtn.Caption:= 'Do it';
  SelectingOn:=True;
end;

procedure TRegistrationForm.LoadListBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir := ImagePath;
    OpenDialog.Filter := 'Image Registration |*.rpl';
    if OpenDialog.Execute then
    begin
      ImagePath := ExtractFilePath(OpenDialog.Filename);
      RegListname := ExtractFileName(OpenDialog.Filename);
      LoadaListFile(RegListname);
    end;
end;
procedure TRegistrationForm.LoadaListFile(RegListname:String);
Begin
{LoadFromFile(ImagePath + RegFilename);}
  ListBox1.Items.LoadFromFile(ImagePath + RegFilename);
  DisplayTheList;
End;

procedure TRegistrationForm.ClearAllBtnClick(Sender: TObject);
begin
  ListBox1.Clear;
  DisplayTheList;
end;

procedure TRegistrationForm.UndoBtnClick(Sender: TObject);
var  i: Integer;
begin
  for i := 0 to (ListBox1.Items.Count - 1) do
    if ListBox1.Selected[i] then
    ListBox1.Items.Delete(i);
  DisplayTheList;
end;

procedure TRegistrationForm.SaveListBtnClick(Sender: TObject);
begin
  ListBox1.Items.SaveToFile(ImagePath + RegFilename);
end;

procedure TRegistrationForm.Image1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  MouseXLabel.Caption:= Inttostr(X);
  MouseYLabel.Caption:= Inttostr(Y);
end;

procedure TRegistrationForm.Image1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If SelectingOn then
  begin
    SelectingOn:=False;
    PlaceItBtn.Caption:= 'One';
    ListBox1.Items.Add(
      'XM: ' + Inttostr(X)+' : '+XEdit.Text +
      'YM: ' + Inttostr(Y)+' : '+YEdit.Text);
    Application.ProcessMessages;
    DisplayTheList;
  end;
end;

procedure TRegistrationForm.DisplayListBtnClick(Sender: TObject);
begin
  DisplayTheList;
end;
procedure TRegistrationForm.DisplayTheList;
var
  Xr,Yr,i: Integer;
  TempLine,Xs,Ys:String;
begin
  if not Image1.Picture.Bitmap.Empty then
  begin
{  BackBitmap.assign(Image1.Picture.Bitmap);}
  Image1.Canvas.Draw(0,0,BackBitmap);
    Image1.Canvas.Brush.Color := clRed;
    Image1.Canvas.Brush.Style := bsDiagCross;
  for i := 0 to (ListBox1.Items.Count - 1) do
  begin
    TempLine:= ListBox1.Items.Strings[i];
      {'XM: ' + Inttostr(X)+' : '+Edit1.Text +
      'YM: ' + Inttostr(Y)+' : '+Edit2.Text);}
      {Copy from after first : to all}
    TempLine:= Copy(TempLine,4,length(TempLine));
      {Copy from start to next : THUS getting X value}
    Xs:=Copy(TempLine,0,pos(':',TempLine)-1);
    Xr:=Strtoint(Xs);
      {Just to skip the :  NOW have ALL the Y}
    TempLine:= Copy(TempLine,pos(':',TempLine)+1,length(TempLine));
      {Copy the Y value out}
    TempLine:= Copy(TempLine,0,pos(':',TempLine)-1);
    Ys:= TempLine;         {X1, Y1, X2, Y2}
    Yr:=Strtoint(Ys);
    Image1.Canvas.Ellipse(Xr-4, Yr-4, Xr+4,  Yr+4);
  end;
  end;
end;

procedure TRegistrationForm.ProcessBtnClick(Sender: TObject);
begin
   {Smear the image per Registration inputs}
  if not Image1.Picture.Bitmap.Empty then
  begin

  end;
end;
{
Delphi 5 main program form TestCurveFit.pas

Purpose: to provide a simple testbed for the procedure PolyFit

Revision history:

2000 Oct 28  First version
2001 Jan 07  Add UpDown button to demonstrate changing the number of terms
             Add more explanatory comments
             Build without requiring Delphi 4 runtime library
2003 Mar 05  Rebuild on Delphi 5
             Add check for errors option when all Y values are the same

Copyright  David J Taylor, Edinburgh and others listed above
Web site:  www.satsignal.net           
E-mail:    davidtaylor@writeme.com
}
procedure TRegistrationForm.UpDownNumTermsClick(Sender: TObject;
  Button: TUDBtnType);
begin
  // When the UpDown control is clicked, try
  // a curve fit with a new number of terms
  Calculate_fit (UpDownNumTerms.Position);
end;

procedure TRegistrationForm.calculate_fit (const nTerms: integer);
const
  max_points = 9;
  max_terms = 5;
var
  nPoints: 1..max_points;
  x, y: array [0..max_points-1] of real;
  coef: array [0..max_terms-1] of real;
  correl: real;
var
  i, j: integer;
  xc, yc, delta: real;
begin
  // Sanity check on arguments
  if (nTerms < 1) or (nTerms > max_terms) then Exit;

  // Fill in the X and Y arrays
  nPoints := 9;
  for i := 0 to nPoints - 1 do x [i] := i + 1;
  y [0] := 2.07;
  y [1] := 8.6;
  y [2] := 14.42;
  y [3] := 15.80;
  y [4] := 18.92;
  y [5] := 17.96;
  y [6] := 12.98;
  y [7] := 6.45;
  y [8] := 0.27;

  // Uncomment the line below to check for bad data causing exception.
//  for i := 0 to 8 do y [i] := 2.0;

  // Remove any existing display of results
  MemoResults.Clear;            

  // Call the PolyFit routine.  The output coeffs array and correl(ation)
  PolyFit (x, y, coef, correl, nPoints, nTerms);

  // Display the results in the lines of a MemoControl
  MemoResults.Lines.Add (' I    X      Y    Ycalc  residual');
  for i := 0 to nPoints - 1 do
    begin
    yc := 0.0;
    xc := 1.0;
    for j := 0 to nTerms - 1 do
      begin
      yc := yc + coef [j] * xc;
      xc := xc * x [i];
      end;
    delta := yc - y [i];
    MemoResults.Lines.Add (Format ('%2d   %3f %6.2f %6.2f %6.2f',
      [i, x [i], y [i], yc, delta]));
    end;
  MemoResults.Lines.Add (' ');
  MemoResults.Lines.Add ('Coefficients');
  MemoResults.Lines.Add (Format ('%.4f  constant term', [coef [0]]));

  for i := 1 to nTerms - 1 do
    MemoResults.Lines.Add (Format ('%.4f   X^%d', [coef [i], i]));
  MemoResults.Lines.Add (Format ('%.4f  correlation coefficient', [correl]));
end;



end.
