unit szMain;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, FileCtrl,
  szScanThread, Menus, Buttons,
  {Registry,}  {FormSettings,} ImgList;

type
   TSortMode = (smName, smSize);

  TszMainForm = class(TForm)
    TopPanel: TPanel;
    DriveComboBox1: TDriveComboBox;
    StatusBar1: TStatusBar;
    FilePanel: TPanel;
    ColorDialog1: TColorDialog;
    szMainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Delete1: TMenuItem;
    Scan1: TMenuItem;
    N2: TMenuItem;
    szFilePopup: TPopupMenu;
    Options1: TMenuItem;
    BarColor1: TMenuItem;
    ScanBut: TSpeedButton;
    BackBut: TSpeedButton;
    ImageList1: TImageList;
    Delete2: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    N3: TMenuItem;
    Launch2: TMenuItem;
    Launch1: TMenuItem;
    N4: TMenuItem;
    FindDup1: TMenuItem;
    LeftPanel: TPanel;
    DirectoryListBox1: TDirectoryListBox;
    RightPanel: TPanel;
    FileList: TListBox;
    PathPanel: TPanel;
    PathLabel: TLabel;
    FileHeader: THeaderControl;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    DirTree: TTreeView;
    N5: TMenuItem;
    AllowMis1: TMenuItem;
    DiskHog1: TMenuItem;
    procedure ScanButClick(Sender: TObject);
    procedure DirTreeClick(Sender: TObject);
    procedure DirTreeChange(Sender: TObject; Node: TTreeNode);
    procedure FileListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FileHeaderSectionTrack(HeaderControl: THeaderControl;
      Section: THeaderSection; Width: Integer; State: TSectionTrackState);
    procedure FileHeaderSectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileHeaderSectionClick(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure FileListDblClick(Sender: TObject);
    procedure ColorButClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure File1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure FilePanelResize(Sender: TObject);
    procedure BackButClick(Sender: TObject);
    procedure szFilePopupPopup(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Launch1Click(Sender: TObject);
    procedure FindDup1Click(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure AllowMis1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure DiskHog1Click(Sender: TObject);
  protected
    Root       : TDirInfo;
    AllFiles   : TList;
    NeedSortDup: boolean;
    w1         : integer;
    DoFill     : boolean;
    SortMode   : TSortMode;
    SortDir    : integer;
    ObjList    : TList;
    MaxSize    : double;
    szMainBarColor   : TColor;
    procedure  SetStat(i: integer; s: string);
    procedure  Calc_Max_Percentage;
{    function   RootKey: string;}
    procedure  AppHint(Sender: TObject);
  public
    { Public declarations }
    DupList    : TList;
    procedure  ThreadDone(Sender: TObject);
    procedure  FillTree(Dir: TDirInfo; Node: TTreeNode);
    procedure  Fill_File_List(Dir: TDirInfo);
{    procedure  SendEmail(const Subject, Msg: string); }
    property   Stat[i: integer]: string write SetStat;
  end;

  function CompareDupFiles(Item1, Item2: Pointer; ComparePath, CompareName: boolean): Integer;
  function CompareDupFiles_Name(Item1, Item2: Pointer; ComparePath: boolean): Integer;


var
  szMainForm: TszMainForm;

implementation

uses TongGlobals, szRecycle, Mapi, ShellAPI,  szDupDlg, PicAbout{, PicAbout};

{$R *.DFM}

function TrimLastSlash(const s: string): string;
begin
   Result := s;
   if Copy(Result, Length(Result), 1) = '\' then
      Result := Copy(Result, 1, Length(Result)-1);
end;

{function TszMainForm.RootKey: string;
begin
   Result := 'Software\DiskHog\';
end; }

procedure TszMainForm.FormCreate(Sender: TObject);
{var
   ini : TRegIniFile;}
begin
   DoFill   := True;
   SortMode := smSize;
   SortDir  := 1;
   ObjList  := TList.Create;
   DupList  := TList.Create;
{   ini := TRegIniFile.Create(RootKey);
   BarColor := ini.ReadInteger('Options', 'BarColor', clFuchsia); // clAqua
   ini.Free;}
   Application.OnHint := AppHint;
end;
procedure TszMainForm.FormShow(Sender: TObject);
begin
  top := szMainFormY;
  left := szMainFormX;
end;

procedure TszMainForm.FormDestroy(Sender: TObject);
begin
   ObjList.Free;
   DupList.Free;
end;
procedure TszMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  szMainFormX := szMainForm.left;
  szMainFormY := szMainForm.top;
end;
procedure TszMainForm.Exit1Click(Sender: TObject);
begin
   Close;
end;
procedure TszMainForm.AppHint(Sender: TObject);
begin
   Stat[2] := Application.Hint;
end;
procedure TszMainForm.About1Click(Sender: TObject);
begin
  PicAboutBox.Init(4);
  PicAboutBox.ShowModal;
end;

procedure TszMainForm.DiskHog1Click(Sender: TObject);
begin
  Application.HelpContext(4500);
end;

procedure TszMainForm.ScanButClick(Sender: TObject);
var
   st : TScanThread;
begin
   Stat[0] := 'Clearing Data';
   Stat[1] := '';
   DoFill := False;
   DirTree.Items.BeginUpdate;
   DirTree.Items.Clear;
   DirTree.Items.EndUpdate;
   FileList.Items.BeginUpdate;
   FileList.Items.Clear;
   FileList.Items.EndUpdate;
   DoFill := True;
   Root.Free;
   Root := nil;
   AllFiles.Free;
   AllFiles := nil;
   NeedSortDup := True;
   ObjList.Clear;
   Update;

   Stat[0] := 'Scanning Directories';

   st := TScanThread.Create(True);
   st.Drive := UpperCase(DriveComboBox1.Drive);
   st.Directory := TrimLastSlash(DirectoryListBox1.Directory);
   st.FreeOnTerminate := False;
   st.OnTerminate := ThreadDone;
   st.MainForm := Self;
   st.Resume;
   ScanBut.Enabled := False;
   Scan1.Enabled := False;
end;

procedure TszMainForm.ThreadDone(Sender: TObject);
var
   st : TScanThread;
begin
   ScanBut.Enabled := True;
   Scan1.Enabled := True;
   FindDup1.Enabled := True;

   st := Sender as TScanThread;
   Root     := st.Root;
   AllFiles := st.AllFiles;
   if st.ErrMsg<>'' then begin
      ShowMessage(st.ErrMsg);
   end else begin
      Assert(Root<>nil);
      FillTree(Root, nil);
      DirTree.Items[0].Expand(False);
      DirTree.Items[0].Selected := True;
      DirTree.SetFocus;
   end;
   Sender.Free;
end;

function DirCompare(Item1, Item2: Pointer): Integer;
begin
   Result := AnsiCompareText(TDirInfo(Item1).Name, TDirInfo(Item2).Name);  
end;

procedure TszMainForm.FillTree(Dir: TDirInfo; Node: TTreeNode);
var
   i        : integer;
   NewNode  : TTreeNode;
begin
   NewNode := DirTree.Items.AddChildObject(Node, Dir.Name, Dir);
   NewNode.SelectedIndex := 1;
   Dir.TreeNode := NewNode;
   Dir.SubDirs.Sort(DirCompare);
   for i := 0 to Dir.SubDirs.Count-1 do
      FillTree(Dir.SubDirs[i], NewNode);
end;


procedure TszMainForm.DirTreeClick(Sender: TObject);
var
   tn       : TTreeNode;
   DirInfo  : TDirInfo;
begin
   if not DoFill then exit;

   tn := DirTree.Selected;
   if tn=nil then exit;
   if not tn.Selected then exit;

   DirInfo := tn.Data;
   Stat[0] := Format('%1.0n directories', [DirInfo.NumDirs+0.0]);
   Stat[1] := Format('%1.0n files', [DirInfo.NumFiles+0.0]);
   Stat[2] := Format('%1.0n bytes   (%1.0n wasted)', [DirInfo.TotBytes, DirInfo.Wasted]);

   Fill_File_List(DirInfo);
end;

procedure TszMainForm.DirTreeChange(Sender: TObject; Node: TTreeNode);
var
   tn : TTreeNode;
   b  : boolean;
begin
   DirTreeClick(Sender);

   tn := DirTree.Selected;
   b := False;
   if tn<>nil then begin
      if tn.Parent<>nil then b := True;
      if tn.Data<>nil then
         PathLabel.Caption := (TObject(tn.Data) as TBaseInfo).FullPath;
   end;
   BackBut.Enabled := b;
end;

function SortFiles(Item1, Item2: Pointer): Integer;
var
   s1, s2   : double;
   d1, d2   : boolean;
begin
   if szMainForm.SortMode = smName then begin
      // Sort by NAME
      Result := AnsiCompareText(TBaseInfo(Item1).Name, TBaseInfo(Item2).Name);
      // Group dirs and files
      d1 := (TObject(Item1) is TDirInfo);
      d2 := (TObject(Item2) is TDirInfo);
      if d1 and (not d2) then Result := -1;
      if (not d1) and d2 then Result := 1;
   end else begin
      // Sort by SIZE
      s1 := TBaseInfo(Item1).Size;
      s2 := TBaseInfo(Item2).Size;
      Result := 0;
      if s1 < s2 then Result := 1;
      if s1 > s2 then Result := -1;
   end;

   Result := Result * szMainForm.SortDir;
end;

procedure TszMainForm.Fill_File_List(Dir: TDirInfo);
var
   i     : integer;
begin
   w1 := FileHeader.Sections[0].Width;

   ObjList.Clear;
   for i := 0 to Dir.SubDirs.Count-1 do ObjList.Add(Dir.SubDirs[i]);
   for i := 0 to Dir.Files.Count-1 do ObjList.Add(Dir.Files[i]);
   ObjList.Sort(SortFiles);

   Calc_Max_Percentage;

   FileList.Items.BeginUpdate;
   FileList.Items.Clear;
   for i := 0 to ObjList.Count-1 do FileList.Items.Add('');
   FileList.Items.EndUpdate;
end;


procedure TszMainForm.FileListDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
   s      : string;
   s2     : double;
   d      : TBaseInfo;
   R      : TRect;
   BarLen : integer;
   ImgIdx : integer;
   w2     : integer;
begin
   with FileList.Canvas do begin
      FillRect(Rect);

      d := ObjList[Index];
      ImgIdx := 2;
      if d is TDirInfo then ImgIdx := 0;
      s  := d.Name;
      s2 := d.Size;

      // Draw the Icon
      ImageList1.Draw(FileList.Canvas, Rect.Left+2, Rect.Top+0, ImgIdx);

      // Draw the Name
      R := Classes.Rect(Rect.Left+2+16+2, Rect.Top+2, Rect.Left + w1-4, Rect.Bottom);
      DrawTextEx(Handle, PChar(s), -1, R, DT_LEFT or DT_BOTTOM or DT_END_ELLIPSIS, nil);

      // Draw the Bar
      Brush.Color := szMainBarColor;
      w2 := FileHeader.Sections[1].Width;
      BarLen := Round((d.Size / MaxSize) * (FileList.ClientWidth-w1-w2-1));
      if BarLen<1 then BarLen := 1;
      FillRect(Classes.Rect(w1+w2, Rect.Top, w1+w2 + BarLen, Rect.Bottom));
      // RoundRect(w1+w2, Rect.Top, w1+w2 + BarLen, Rect.Bottom, 5, 3);
      Brush.Color := clWhite;

      // Draw the Size
      Brush.Style := bsClear;
      TextOut(w1 + 2, Rect.Top + 2, Format('%1.0n', [s2]));
      Brush.Style := bsSolid;
   end;
end;

procedure TszMainForm.SetStat(i: integer; s: string);
begin
   StatusBar1.Panels[i].Text := s;
   // StatusBar1.Update;
end;


procedure TszMainForm.FileHeaderSectionTrack(HeaderControl: THeaderControl;
  Section: THeaderSection; Width: Integer; State: TSectionTrackState);
begin
   if Section.ID = 0 then begin
      w1 := Width;
      FileList.Refresh;
      FileHeader.Sections[0].Width := w1;
      FileHeader.Refresh;
   end;
   if Section.ID = 1 then begin
      FileList.Refresh;
      FileHeader.Sections[1].Width := Width;
      FileHeader.Refresh;
   end;
end;

procedure TszMainForm.FileHeaderSectionResize(HeaderControl: THeaderControl;
  Section: THeaderSection);
begin
   FileList.Invalidate;
   w1 := FileHeader.Sections[0].Width;
end;


procedure TszMainForm.FileHeaderSectionClick(HeaderControl: THeaderControl;
  Section: THeaderSection);
var
   NewSortMode : TSortMode;
   bi          : TBaseInfo;
   i           : integer;
begin
   case Section.ID of
      0 : NewSortMode := smName;
      1 : NewSortMode := smSize;
      else NewSortMode := smName;
   end;
   if NewSortMode = SortMode then SortDir := SortDir * -1
      else SortDir := 1;
   SortMode := NewSortMode;

   // Sort the list (and maintain the current selection if necessary)
   bi := nil;
   i := FileList.ItemIndex;
   if i<>-1 then
      bi := ObjList.Items[i];
   ObjList.Sort(SortFiles);
   FileList.ItemIndex := ObjList.IndexOf(bi);
   FileList.SetFocus;

   FileList.Invalidate;
end;

procedure TszMainForm.FileListDblClick(Sender: TObject);
var
   i  : integer;
   di : TDirInfo;
begin
   i := FileList.ItemIndex;
   if i=-1 then exit;

   if TObject(ObjList[i]) is TDirInfo then
   begin
      di := TDirInfo(ObjList[i]);
      di.TreeNode.Selected := True;
   end;
end;

procedure TszMainForm.Calc_Max_Percentage;
var
   i   : integer;
   Max : double;
begin
   Max := 1;

   for i := 0 to ObjList.Count-1 do
      if TBaseInfo(ObjList[i]).Size > Max then
         Max := TBaseInfo(ObjList[i]).Size;

   MaxSize := Max;
end;


procedure TszMainForm.ColorButClick(Sender: TObject);
{var   ini : TRegIniFile;}
begin
   ColorDialog1.Color := szMainBarColor;
   if ColorDialog1.Execute then begin
      szMainBarColor := ColorDialog1.Color;
      FileList.Invalidate;
      {ini := TRegIniFile.Create(RootKey);
      ini.WriteInteger('Options', 'BarColor', BarColor);
      ini.Free;}
   end;
end;


procedure TszMainForm.File1Click(Sender: TObject);
var
   i : integer;
   b : boolean;
begin
   i := FileList.ItemIndex;
   b := False;
   if i<>-1 then
   begin
      b := TObject(ObjList[i]) is TFileInfo;
   end;
   Delete1.Enabled := b;
   Launch1.Enabled := i<>-1;
end;

procedure TszMainForm.Delete1Click(Sender: TObject);
var
   i  : integer;
   bi : TBaseInfo;
   di : TDirInfo;
begin
   i := FileList.ItemIndex;
   bi := ObjList[i];
   Assert(bi<>nil);
   di := bi.Parent;
   Assert(di<>nil);

   if RecycleFile(bi.FullPath) and (not FileExists(bi.FullPath)) then begin
      FileList.Items.Delete(i);
      ObjList.Delete(i);
      di.Files.Delete(di.Files.IndexOf(bi));
      while di<>nil do with di do begin
         Size     := Size - bi.Size;
         Wasted   := Wasted - bi.Wasted;
         NumFiles := NumFiles - 1;
         di := di.Parent;
      end;
      bi.Free;
      Calc_Max_Percentage;
      DirTreeChange(nil, nil);
   end;
end;

procedure TszMainForm.FilePanelResize(Sender: TObject);
begin
   FileList.Invalidate;
end;

procedure TszMainForm.BackButClick(Sender: TObject);
var
   tn : TTreeNode;
begin
   tn := DirTree.Selected;
   if tn<>nil then begin
      if tn.Parent<>nil then begin
         tn.Parent.Selected := True;
         DirTree.SetFocus;
      end;
   end;
end;

procedure TszMainForm.szFilePopupPopup(Sender: TObject);
begin
   File1Click(nil);
   Delete2.Enabled := Delete1.Enabled;
   Launch2.Enabled := Launch1.Enabled;
end;


{procedure TszMainForm.SendEmail(const Subject, Msg: string);
var
   MapiMessage : TMapiMessage;
   MError      : Cardinal;
begin
   with MapiMessage do begin
      ulReserved := 0;
      lpszSubject := PChar(Subject);
      lpszNoteText := PChar(Msg);
      lpszMessageType := nil;
      lpszDateReceived := nil;
      lpszConversationID := nil;
      flFlags := 0;
      lpOriginator := nil;
      nRecipCount := 0;
      lpRecips := nil;
      nFileCount := 0;
      lpFiles := nil;
   end;

   MError := MapiSendMail(0, 0, MapiMessage,
      MAPI_DIALOG or MAPI_LOGON_UI or MAPI_NEW_SESSION, 0);
   if MError <> 0 then
      MessageDlg('Unable to send mail message!'#13#10'MAPI Error = ' + IntToStr(MError), mtError, [mbOK], 0);
end;}

{procedure TszMainForm.Send1Click(Sender: TObject);
const
   CR = #13#10;
var
   i        : integer;
   Sub, Msg : string;
   typ      : string;
   bi       : TBaseInfo;
begin
   Sub := Format('Re:  Disk Usage on Drive: "%s"', [DriveComboBox1.Text]);
   Msg := Sub + CR;
   bi := nil;
   if DirTree.Selected<>nil then bi := DirTree.Selected.Data;
   i := FileList.ItemIndex;
   if i<>-1 then bi := ObjList[i];
   if bi<>nil then begin
      typ := 'File/Folder';
      if bi is TFileInfo then typ := 'File';
      if bi is TDirInfo then typ := 'Folder';
      Msg := Msg + Format('%s "%s" takes up %1.0n bytes', [typ, bi.Name, bi.Size+0.0]) + CR;
   end;

   with szEmailForm do begin
      SubjEdit.Text := Sub;
      BodyMemo.Text := Msg;
      if ShowModal = mrOK then
         SendEmail(SubjEdit.Text, BodyMemo.Text);
   end;
end;}

procedure TszMainForm.Launch1Click(Sender: TObject);
var
   i  : integer;
   bi : TBaseInfo;
   rc : integer;
begin
   i := FileList.ItemIndex;
   bi := ObjList[i];
   Assert(bi<>nil);

   rc := ShellExecute(0, 'open', PChar(bi.FullPath), nil, nil, SW_SHOWNORMAL);
   if rc > 32 then ;
{   Assert(rc > 32, 'Unable to execute: ' + bi.FullPath);}
end;

function CompareFloat(d1, d2: double): integer;
begin
   if d1 < d2 then Result := 1
      else if d1 > d2 then Result := -1
         else Result := 0;
end;

function CompareDupFiles(Item1, Item2: Pointer; ComparePath, CompareName: boolean): Integer;
var
   b1, b2 : TBaseInfo;
begin
   b1 := Item1;
   b2 := Item2;
   Result := CompareFloat(b1.Size, b2.Size);
   if Result<>0 then exit;

   if CompareName then begin
      Result := AnsiCompareText(b1.Name, b2.Name);
      if Result<>0 then exit;
   end;

   if ComparePath then begin
      Result := AnsiCompareText(b1.FullPath, b2.FullPath);
      if Result<>0 then exit;
   end;
end;

function CompareDupFiles_Name(Item1, Item2: Pointer; ComparePath: boolean): Integer;
var
   b1, b2 : TBaseInfo;
begin
   b1 := Item1;
   b2 := Item2;
   Result := AnsiCompareText(b1.Name, b2.Name);
   if Result<>0 then exit;
   Result := CompareFloat(b1.Size, b2.Size);
   if Result<>0 then exit;
   if ComparePath then begin
      Result := AnsiCompareText(b1.FullPath, b2.FullPath);
      if Result<>0 then exit;
   end;
end;

function DupSortFiles(Item1, Item2: Pointer): Integer;
begin
   Result := CompareDupFiles(Item1, Item2, True, True);
end;

procedure TszMainForm.FindDup1Click(Sender: TObject);
var
   i           : integer;
   AddedPrev   : boolean;
   LostSpace   : double;
   NumDup      : integer;
begin
   if NeedSortDup then begin
      // NeedSortDup := False;   // Always force it to recalculate

      Screen.Cursor := crHourGlass;
      AllFiles.Sort(DupSortFiles);
      DupList.Clear;
      DupList.Capacity := 4096;

      LostSpace := 0;
      NumDup := 0;
      AddedPrev := False;
      for i := 0 to AllFiles.Count-2 do begin
         if CompareDupFiles(AllFiles[i], AllFiles[i+1], False, not AllowMis1.Checked) = 0 then begin
            LostSpace := LostSpace + TFileInfo(AllFiles[i+1]).Size;
            NumDup := NumDup + 1;
            if AddedPrev=False then DupList.Add(AllFiles[i]);
            DupList.Add(AllFiles[i+1]);
            AddedPrev := True;
         end else
            AddedPrev := False;
      end;

      with szDupForm do begin
         ListBox1.Items.BeginUpdate;
         ListBox1.Items.Clear;
         for i := 0 to DupList.Count-1 do ListBox1.Items.Add('');
         ListBox1.Items.EndUpdate;
         StatusBar1.Panels[0].Text := Format('Duplicates = %1.0n', [NumDup+0.0]);
         StatusBar1.Panels[1].Text := Format('Lost Space (to duplicates) = %1.0n bytes', [LostSpace]);
      end;
      Screen.Cursor := crDefault;
   end;

   szDupForm.AllowMisBox.Visible := AllowMis1.Checked;
   szDupForm.ShowModal;
end;

procedure TszMainForm.DriveComboBox1Change(Sender: TObject);
begin
   DirectoryListBox1.Drive := DriveComboBox1.Drive;
   DirectoryListBox1.Directory := DriveComboBox1.Drive + ':\';
end;

procedure TszMainForm.AllowMis1Click(Sender: TObject);
begin
   AllowMis1.Checked := not AllowMis1.Checked;
end;









end.
