unit t3de1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLWin32Viewer, GLMisc, GLTexture, GLContext,
  OpenGL1x, VectorGeometry, GLCadencer, ExtCtrls, StdCtrls, ComCtrls;

type
  Tt3de1Form = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera1: TGLCamera;
    GLDummyCube1: TGLDummyCube;
    GLDirectOpenGL1: TGLDirectOpenGL;
    GLCadencer1: TGLCadencer;
    Timer1: TTimer;
    Panel1: TPanel;
    MinTrackBar: TTrackBar;
    MaxTrackBar: TTrackBar;
    MinLabel: TLabel;
    MaxLabel: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    SliceTrackBar: TTrackBar;
    SliceLabel: TLabel;
    CheckBox2: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Panel2: TPanel;
    ColorDialog1: TColorDialog;
    procedure GLDirectOpenGL1Render(var rci: TRenderContextInfo);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure Timer1Timer(Sender: TObject);
    procedure MinTrackBarChange(Sender: TObject);
    procedure MaxTrackBarChange(Sender: TObject);
    procedure SliceTrackBarChange(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure GLSceneViewer1MouseEnter(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    mx, my : Integer;
    MyX, Diagonal:Single;
    tex3d : TGLTextureHandle;
  end;

var
  t3de1Form: Tt3de1Form;

implementation

{$R *.dfm}
uses  TongGlobals;//dtmPOFvar,dtmGlobals;
const
   texSize = 256;

{var
	clip0 : array [0..3] of Double = (-1.0,  0.0,  0.0, 1/2.0);
	clip1 : array [0..3] of Double = ( 1.0,  0.0,  0.0, 1/2.0);
	clip2 : array [0..3] of Double = ( 0.0, -1.0,  0.0, 1/2.0);
	clip3 : array [0..3] of Double = ( 0.0,  1.0,  0.0, 1/2.0);
	clip4 : array [0..3] of Double = ( 0.0,  0.0, -1.0, 1/2.0);
	clip5 : array [0..3] of Double = ( 0.0,  0.0,  1.0, 1/2.0);}

(*
after commenting out the glEnable(GL_CLIP_PLANE?) lines,
my framerate jumped from 13 FPS to 23 FPS,
which could mean the CLIP_PLANE implementation for my GeForce3 is horrendous
 (and we could probably gain by performing it on the GLScene side).
 Anyone can confirm this for other graphics hardware?

Another note, when I disable the TGLDummyCube's VisibleAtRunTime,
I gain another 10 to 11 fps.
*)
procedure Tt3de1Form.GLDirectOpenGL1Render(var rci: TRenderContextInfo);
const
{   diagonal = 1.73; }
   layers = 256;//100;
type
  Count3D = array[0..255] of Byte;
  P_Longword = ^Longword;
var
   data : String;
   Index,i : Integer;
   step, z : Single;
   mat : TMatrix;
   v : TVector;
   vx, vy, vz : TAffineVector;
  RX, GY, BZ, Value: Byte;
  fLoad: file of Count3D;
  Count3DArray: Count3D;
begin
   if tex3D.Handle=0 then begin
      {data:=LoadStringFromFile('head.tex');}
  SetLength(data, (256* 256* 256*4));
  {Read em in}
  {$I-}
  AssignFile(fLoad, Tempt3dName);
  Reset(fLoad);
  for BZ := 0 to 255 do
  begin
    for GY := 0 to 255 do
    begin {Row}
      Read(fLoad, Count3DArray);
      for RX := 0 to 255 do
      begin {Col}
        Value := Count3DArray[RX];
        Index := (BZ * 256 * 256) + (GY *256) + RX;
        {HisMatrix[RX, GY, BZ] := Value;}
{        P_Longword} PByte(Integer (PChar (Data)) + (Index * 4))^ := Value;
      end;
    end;
  end;
    CloseFile(fLoad);
  {$I+}
      tex3D.AllocateHandle;
	   glBindTexture(GL_TEXTURE_3D, tex3D.Handle);
   	glTexParameterf(GL_TEXTURE_3D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	   glTexParameterf(GL_TEXTURE_3D, GL_TEXTURE_WRAP_T, GL_CLAMP);
   	glTexParameterf(GL_TEXTURE_3D, GL_TEXTURE_WRAP_R, GL_CLAMP);
	   glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MIN_FILTER,GL_LINEAR);
   	glTexParameteri(GL_TEXTURE_3D, GL_TEXTURE_MAG_FILTER,GL_LINEAR);
{PS: You can gain 1-2 FPS by replacing the GL_RGBA8 with
    GL_LUMINANCE_ALPHA in the glTexImage3D call.}
{	   glTexImage3DEXT(GL_TEXTURE_3D, 0, GL_RGBA8, texSize, texSize, texSize,
                      0, GL_RGBA, GL_UNSIGNED_BYTE, PChar(data)); }

	   glTexImage3DEXT(GL_TEXTURE_3D, 0, GL_LUMINANCE_ALPHA, texSize, texSize, texSize,
                      0, GL_RGBA, GL_UNSIGNED_BYTE, PChar(data));
   end;

   glPushAttrib(GL_ENABLE_BIT);
   glPushMatrix;

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   glDisable(GL_CULL_FACE);
   glDisable(GL_LIGHTING);

	glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
	glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
	glTexGenf(GL_R, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
   SetVector(v, XVector, 0.5);
	glTexGenfv(GL_S, GL_OBJECT_PLANE, @v);
   SetVector(v, YVector, 0.5);
	glTexGenfv(GL_T, GL_OBJECT_PLANE, @v);
   SetVector(v, ZVector, 0.5);
	glTexGenfv(GL_R, GL_OBJECT_PLANE, @v);
	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glEnable(GL_TEXTURE_GEN_R);

 {	glClipPlane(GL_CLIP_PLANE0, @clip0);
	glClipPlane(GL_CLIP_PLANE1, @clip1);
	glClipPlane(GL_CLIP_PLANE2, @clip2);
	glClipPlane(GL_CLIP_PLANE3, @clip3);
	glClipPlane(GL_CLIP_PLANE4, @clip4);
	glClipPlane(GL_CLIP_PLANE5, @clip5);

   glEnable(GL_CLIP_PLANE0);
   glEnable(GL_CLIP_PLANE1);
   glEnable(GL_CLIP_PLANE2);
   glEnable(GL_CLIP_PLANE3);
   glEnable(GL_CLIP_PLANE4);
   glEnable(GL_CLIP_PLANE5); }

	glBindTexture(GL_TEXTURE_3D, tex3d.Handle);
	glEnable(GL_TEXTURE_3D);

   glGetFloatv(GL_MODELVIEW_MATRIX, @mat);
   vx[0]:=mat[0][0];  vy[0]:=mat[0][1];  vz[0]:=mat[0][2];
   vx[1]:=mat[1][0];  vy[1]:=mat[1][1];  vz[1]:=mat[1][2];
   vx[2]:=mat[2][0];  vy[2]:=mat[2][1];  vz[2]:=mat[2][2];
   ScaleVector(vx, diagonal*0.5/VectorLength(vx));
   ScaleVector(vy, diagonal*0.5/VectorLength(vy));

	step:=diagonal/layers;
   z:=-diagonal/2;
   glBegin(GL_QUADS);
   If CheckBox1.Checked then
   begin
     z:=z+(step*SliceTrackBar.Position);
      glVertex3f( vx[0]+vy[0]+vz[0]*z, vx[1]+vy[1]+vz[1]*z, vx[2]+vy[2]+vz[2]*z);
      glVertex3f(-vx[0]+vy[0]+vz[0]*z,-vx[1]+vy[1]+vz[1]*z,-vx[2]+vy[2]+vz[2]*z);
      glVertex3f(-vx[0]-vy[0]+vz[0]*z,-vx[1]-vy[1]+vz[1]*z,-vx[2]-vy[2]+vz[2]*z);
      glVertex3f( vx[0]-vy[0]+vz[0]*z, vx[1]-vy[1]+vz[1]*z, vx[2]-vy[2]+vz[2]*z);
   end else
   for i:= MinTrackBar.Position to MaxTrackBar.Position do begin
      glVertex3f( vx[0]+vy[0]+vz[0]*z, vx[1]+vy[1]+vz[1]*z, vx[2]+vy[2]+vz[2]*z);
      glVertex3f(-vx[0]+vy[0]+vz[0]*z,-vx[1]+vy[1]+vz[1]*z,-vx[2]+vy[2]+vz[2]*z);
      glVertex3f(-vx[0]-vy[0]+vz[0]*z,-vx[1]-vy[1]+vz[1]*z,-vx[2]-vy[2]+vz[2]*z);
      glVertex3f( vx[0]-vy[0]+vz[0]*z, vx[1]-vy[1]+vz[1]*z, vx[2]-vy[2]+vz[2]*z);
      z:=z+step;
   end;
   glEnd;

	 glPopMatrix;
   glPopAttrib;
end;

procedure Tt3de1Form.FormCreate(Sender: TObject);
begin
  { Check for Capable Card}
   Assert (GL_EXT_texture3D, 'Graphic card does not support 3D textures.');
   diagonal:=1.730000;
   MyX:=0.5;
   tex3D:=TGLTextureHandle.Create;
  top := Tongt3de1FormY;
  left := Tongt3de1FormX;
end;
procedure Tt3de1Form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Tongt3de1FormY := t3de1Form.top;
  Tongt3de1FormX := t3de1Form.left;
end;
procedure Tt3de1Form.FormDestroy(Sender: TObject);
begin
   tex3D.Free;
end;

procedure Tt3de1Form.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   mx:=x; my:=y;
end;

procedure Tt3de1Form.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
   if ((ssLeft in Shift))then
     GLCamera1.MoveAroundTarget(my-y, mx-x);

  {You can move through the head... if positioned properly
  But the Dummy Cube will Bounce you past Infinity if you go past it}
  If Shift = [ssRight] Then
      GLCamera1.Position.AddScaledVector ((my - y) * 0.01, GLCamera1.AbsoluteVectorToTarget);
   if ((ssRight in Shift)and(ssShift in Shift))then
       GLDummyCube1.Position.Y:=GLDummyCube1.Position.Y+ ((my-y)* 0.01);
   if ((ssRight in Shift)and(ssCtrl in Shift))then
       GLDummyCube1.Position.X:=GLDummyCube1.Position.X+ ((mx-x)* 0.01);

  mx:=x; my:=y;
end;

procedure Tt3de1Form.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
   GLSceneViewer1.Invalidate;
end;

procedure Tt3de1Form.Timer1Timer(Sender: TObject);
begin
   Caption:='Brains: '+ GLSceneViewer1.FramesPerSecondText;
   GLSceneViewer1.ResetPerformanceMonitor;
end;

procedure Tt3de1Form.MinTrackBarChange(Sender: TObject);
begin
  If MinTrackBar.Position > MaxTrackBar.Position then
   MinTrackBar.Position:=MaxTrackBar.Position-1;
  MinLabel.Caption:=Inttostr(MinTrackBar.Position);
end;

procedure Tt3de1Form.MaxTrackBarChange(Sender: TObject);
begin
  If MaxTrackBar.Position < MinTrackBar.Position then
   MaxTrackBar.Position:=MinTrackBar.Position+1;
  MaxLabel.Caption:=Inttostr(MaxTrackBar.Position);
end;

procedure Tt3de1Form.SliceTrackBarChange(Sender: TObject);
begin
  SliceLabel.Caption:=Inttostr(SliceTrackBar.Position);
end;

procedure Tt3de1Form.CheckBox2Click(Sender: TObject);
begin
   GLDummyCube1.Visible:=CheckBox2.Checked;
end;

procedure Tt3de1Form.CheckBox1Click(Sender: TObject);
begin
  If CheckBox1.Checked then
  Label6.Caption:='Personally, I would have squeezed a little bit Tighter'
  else Label6.Caption:='';
end;

procedure Tt3de1Form.Panel2Click(Sender: TObject);
begin
  ColorDialog1.Color:=Panel2.Color;
  if ColorDialog1.Execute then
  begin
    Panel2.Color := ColorDialog1.Color;
    GLSceneViewer1.Buffer.BackgroundColor:=
      Panel2.Color;
  end;
end;

procedure Tt3de1Form.GLSceneViewer1MouseEnter(Sender: TObject);
begin
   GLSceneViewer1.SetFocus;
end;

procedure Tt3de1Form.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  Handled:=True; {Keep from affecting other controls}
end;

procedure Tt3de1Form.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if key = VK_ESCAPE then close;
end;



end.
